#include <bits/stdc++.h>
/*
5 10
1 3 1 3
3 2 3 2
2 1 2 1
1 4 1 4
4 5 4 5
3
1 4
1 3
4 4
*/
const long long mod = (long long)1e9 + 7;
using namespace std;
list<int>* adj;
vector<set<int>> sccs;
stack<int> reordered;
void dfs(int i, bool visited[]) {
    visited[i] = true;

    for(auto j = adj[i].begin(); j != adj[i].end(); j++) {
        if(!visited[*j]) {
            dfs(*j, visited);
        }
    }

    reordered.push(i);
}

void addScc(int i, bool visited[], list<int> reversed[], int counter) {
    visited[i] = true;
    sccs[counter].insert(i);
    for(auto j = reversed[i].begin(); j != reversed[i].end(); j++) {
        if(!visited[*j]) {
            addScc(*j, visited, reversed, counter);
        }
    }
}
void scc(int n) {
    bool visited[n];
    for(int i = 0; i < n; i++) {
        visited[i] = false;
    }
    for(int i = 0; i < n; i++) {
        if(!visited[i]) {
            dfs(i, visited);
        }
    }

    list<int> reversed[n];
    for(int i = 0; i < n; i++) {
        for(auto it = adj[i].begin(); it != adj[i].end(); it++) {
            reversed[*it].push_back(i);
        }
    }

    for(int i = 0; i < n; i++) {
        visited[i] = false;
    }
    int counter = 0;
    while(!reordered.empty()) {
        int curr = reordered.top();
        reordered.pop();

        if(!visited[curr]) {
            sccs.resize(counter + 1);
            addScc(curr, visited, reversed, counter++);
        }
    }
}

bool isScc(int a, int b) {
    for(int i = 0; i < sccs.size(); i++) {
        if(sccs[i].find(a) != sccs[i].end() && sccs[i].find(b) != sccs[i].end()) return true;
    }
    return false;
}

int modPow(int a, int b) {
    if(b <= 0) return 1;
    int res = 1;
    int curr = b;
    while(b != 0) {
        if(b % 2 == 1) {
            res *= b;
            res %= mod;
        }
        curr *= curr;
        curr %= mod;
        b /= 2;
    }

    return res;
}
int main() {

    int n, m;
    cin >> n >> m;
    adj = new list<int>[n];
    for(int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        adj[u].push_back(v);
    }
    scc(n);
    int q;
    cin >> q;
    int res = 0;
    if(q == 0) {
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < n; j++) {
                if(isScc(i, j)) {
                    res += pow(j+1, (n - i) * (n - j) - 1) * (m + 1);
                    res %= mod;
                }
            }
        }
    }
    else {
        while(q--) {
            int a, b;
            cin >> a >> b;
            if(isScc(--a, --b)) {
                    res += pow(b + 1, q) * (m + 1);
                    res %= mod;
            }
        }
    }
    cout << res << endl;
    return 0;
}
