#include <bits/stdc++.h>
/*
5 10
1 3 1 3
3 2 3 2
2 1 2 1
1 4 1 4
4 5 4 5
3
1 4
1 3
4 4
*/
const long long mod = (long long)1e9 + 7;
const long long B = 2 * (long long)1e5;
using namespace std;
list<long long>* adj;
vector<set<long long>> sccs;
stack<long long> reordered;
void dfs(long long i, bool visited[]) {
    visited[i] = true;

    for(auto j = adj[i].begin(); j != adj[i].end(); j++) {
        if(!visited[*j]) {
            dfs(*j, visited);
        }
    }

    reordered.push(i);
}

void addScc(long long i, bool visited[], list<long long> reversed[], long long counter) {
    visited[i] = true;
    sccs[counter].insert(i);
    for(auto j = reversed[i].begin(); j != reversed[i].end(); j++) {
        if(!visited[*j]) {
            addScc(*j, visited, reversed, counter);
        }
    }
}
void scc(long long n) {
    bool visited[n];
    for(long long i = 0; i < n; i++) {
        visited[i] = false;
    }
    for(long long i = 0; i < n; i++) {
        if(!visited[i]) {
            dfs(i, visited);
        }
    }

    list<long long> reversed[n];
    for(long long i = 0; i < n; i++) {
        for(auto it = adj[i].begin(); it != adj[i].end(); it++) {
            reversed[*it].push_back(i);
        }
    }

    for(long long i = 0; i < n; i++) {
        visited[i] = false;
    }
    long long counter = 0;
    while(!reordered.empty()) {
        long long curr = reordered.top();
        reordered.pop();

        if(!visited[curr]) {
            sccs.resize(counter + 1);
            addScc(curr, visited, reversed, counter++);
        }
    }
}

bool isScc(long long a, long long b) {
    for(long long i = 0; i < sccs.size(); i++) {
        if(sccs[i].find(a) != sccs[i].end() && sccs[i].find(b) != sccs[i].end()) return true;
    }
    return false;
}

long long modPow(long long a, long long b) {
    if(b <= 0) return 1;
    long long res = 1;
    long long curr = a;
    while(b != 0) {
        if(b % 2 == 1) {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        curr %= mod;
        b /= 2;
    }

    return res;
}
int main() {
    long long n, m;
    cin >> n >> m;
    adj = new list<long long>[n];
    for(long long i = 0; i < m; i++) {
        long long u, v;
        cin >> u >> v;
        u--;v--;
        adj[u].push_back(v);
    }
    scc(n);
    long long q;
    cin >> q;
    long long res = 0;
    if(q == 0) {
        q = ((n + 1) * n) / 2 - 1;
        for(long long i = 0; i < n; i++)
        {
            for(long long j = i; j < n; j++) {
                /*if(i == 0 && j == 3 || i == 2 && j == 3 || i == 3 && j == 4) {
                    res += modPow(B, q);
                    res %= mod;
                    cout << 1 << " ";
                }*/
                if(isScc(i, j)) {
                    //cout << m + 1 << " ";
                    res += (modPow(B, q) * (m + 1)) % mod;
                    res %= mod;
                } else {
                    //cout << 0 << " ";
                }
                q--;
            }
        }
    }
    else {
        while(q) {
            long long a, b;
            cin >> a >> b;
            if(isScc(--a, --b)) {
                    res += modPow(B, q - 1) * (m + 1);
                    res %= mod;
            }
            q--;
        }
    }
    cout << res << endl;
    return 0;
}
