#include <bits/stdc++.h>
/*
5 10
1 3 1 3
3 2 3 2
2 1 2 1
1 4 1 4
4 5 4 5
3
1 4
1 3
4 4
*/
const long long mod = (long long)1e9 + 7;
const long long B = 2 * (long long)1e5;
using namespace std;
list<long long>* adj;
map<pair<long long, long long>, long long> ids;
map<long long, pair<long long, long long>> ids2;
vector<set<long long>> sccs;
stack<long long> reordered;
void dfs(long long i, bool visited[]) {
    visited[i] = true;

    for(auto j = adj[i].begin(); j != adj[i].end(); j++) {
        if(!visited[*j]) {
            dfs(*j, visited);
        }
    }

    reordered.push(i);
}

void addScc(long long i, bool visited[], list<long long> reversed[], long long counter) {
    visited[i] = true;
    sccs[counter].insert(i);
    for(auto j = reversed[i].begin(); j != reversed[i].end(); j++) {
        if(!visited[*j]) {
            addScc(*j, visited, reversed, counter);
        }
    }
}
void scc(long long n) {
    bool visited[n];
    for(long long i = 0; i < n; i++) {
        visited[i] = false;
    }
    for(long long i = 0; i < n; i++) {
        if(!visited[i]) {
            dfs(i, visited);
        }
    }

    list<long long> reversed[n];
    for(long long i = 0; i < n; i++) {
        for(auto it = adj[i].begin(); it != adj[i].end(); it++) {
            reversed[*it].push_back(i);
        }
    }

    for(long long i = 0; i < n; i++) {
        visited[i] = false;
    }
    long long counter = 0;
    while(!reordered.empty()) {
        long long curr = reordered.top();
        reordered.pop();

        if(!visited[curr]) {
            sccs.resize(counter + 1);
            addScc(curr, visited, reversed, counter++);
        }
    }
}

bool findPath(list<long long> g[], long long curr, long long dest, bool visited[]) {
    visited[curr] = true;
    //cout << dest << endl;
    if(curr == dest) return true;
    for(auto j = g[curr].begin(); j != g[curr].end(); j++) {
        if(*j == dest) return true;
        if(!visited[*j]) {
            if(findPath(g, *j, dest, visited)) {
                return true;
            }
        }
    }

    return false;
}

int isScc(long long a, long long b, long long n) {
    if(a == b) return -1;
    bool is = false;
    for(long long i = 0; i < sccs.size(); i++) {
        if(sccs[i].find(a) != sccs[i].end() && sccs[i].find(b) != sccs[i].end()) {
            is = true;
            vector<long long> q;
            list<long long> sccL[n];
            for(auto it : sccs[i]) {
                for(auto j = adj[it].begin(); j != adj[it].end(); j++) {
                    if(sccs[i].find(*j) != sccs[i].end()) {
                        sccL[it].push_back(*j);
                        if(count(adj[it].begin(), adj[it].end(), *j) == 1) {
                            q.push_back((*ids.find({it, *j})).second);
                        }
                    }
                }
            }
            sort(q.begin(), q.end());
            reverse(q.begin(), q.end());
            for(auto it : q) {
                long long id = q.back();
                long long from = ids2[id].first, to = ids2[id].second;
                bool visited1[n];
                bool visited2[n];
                for(int i = 0; i < n; i++) {
                    visited1[i] = false;
                    visited2[i] = false;
                }
                sccL[from].erase(find(sccL[from].begin(), sccL[from].end(), to));
                if(!findPath(sccL, a, b, visited1) || !findPath(sccL, b, a, visited2)) {
                    //cout << "id: " << id << endl;
                    return id;
                }
                sccL[from].push_back(to);
                q.pop_back();
            }

        }
    }
    if(is == true)
        return -1;
    return 0;
}

long long modPow(long long a, long long b) {
    if(b <= 0) return 1;
    long long res = 1;
    long long curr = a;
    while(b != 0) {
        if(b % 2 == 1) {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        curr %= mod;
        b /= 2;
    }

    return res;
}
int main() {
    long long n, m;
    cin >> n >> m;
    adj = new list<long long>[n];
    for(long long i = 0; i < m; i++) {
        long long u, v;
        cin >> u >> v;
        u--;v--;
        adj[u].push_back(v);
        if(ids.find({u, v}) == ids.end()) {
            ids.insert({{u, v}, i + 1});
            ids2.insert({i + 1, {u, v}});
        }
    }
    scc(n);
    long long q;
    cin >> q;
    long long res = 0;
    if(q == 0) {
        q = ((n + 1) * n) / 2 - 1;
        for(long long i = 0; i < n; i++)
        {
            for(long long j = i; j < n; j++) {
                long long c = isScc(i, j, n);
                if(c == -1) {
                    //cout << m + 1 << " ";
                    res += (modPow(B, q) * (m + 1)) % mod;
                    res %= mod;
                } else if(c != 0){
                    //cout << c << " ";
                    res += (modPow(B, q) * c) % mod;
                    res %= mod;
                } //else {
                    //cout << 0 << " ";
                //}
                q--;
            }
        }
    }
    else {
        while(q) {
            long long a, b;
            cin >> a >> b;
            long long c = isScc(--a, --b, n);
                if(c == -1) {
                    cout << m + 1 << " ";
                    res += (modPow(B, q - 1) * (m + 1)) % mod;
                    res %= mod;
                } else if(c != 0){
                    cout << c << " ";
                    res += (modPow(B, q - 1) * c) % mod;
                    res %= mod;
                }
            q--;
        }
    }
    cout << res << endl;
    return 0;
}
