#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2048;
int n, m, q, used[maxn], matrix[maxn][maxn], a[maxn], b[maxn];

struct edge{
    int x, idx;
};

vector<edge> v[maxn];

void read(){
    cin >> n >> m;
    for(int i = 1;i <= m;i++){
        cin >> a[i] >> b[i];
        v[a[i]].push_back({b[i],i});
    }
}

void dfs(int start_ver, int ver){
    used[ver] = 1;
    matrix[start_ver][ver] = 1;
    for(edge nb : v[ver]){
        if(!used[nb.x])
            dfs(start_ver, nb.x);
    }
}

int noPath[maxn][maxn];

void preCompute(){
    for(int i = 1;i <= n;i++){
        dfs(i, i);
        memset(used, 0, sizeof(used));
    }
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            if(!matrix[i][j] || !matrix[j][i])
                noPath[i][j] = 1;
        }
    }
    memset(matrix, 0, sizeof(matrix));
}

const int mod = 1e9 + 7;
long long ans = 0;

void answer(long long s, long long step){
    long long res = s, B = 2e5;
    while(step){
        if(step % 2){
            res *= B;
            res %= mod;
        }
        step /= 2;
        B *= B;
        B %= mod;
    }
    ans += res;
    ans %= mod;
}

bool t = false;
void DFS(int final_ver, int ver, int proh){
    if(t)
        return;
    if(ver == final_ver){
        t = true;
        return;
    }
    used[ver] = 1;
    for(edge nb : v[ver]){
        if(nb.idx == proh) continue;
        if(!used[nb.x])
            DFS(final_ver, nb.x, proh);
    }
}

void solve(){
    cin >> q;
    if(q == 0){
        for(int i = 1;i <= n;i++){
            for(int j = 1;j <= n;j++){
                for(int k = 1;k <= m;k++){
                    t = false;
                    memset(used, 0, sizeof(used));
                    DFS(j, i, k);
                    if(!t){
                        matrix[i][j] = k;
                        break;
                    }

                }
                if(matrix[i][j] == 0)
                    matrix[i][j] = m + 1;
            }
        }
        for(int i = 1;i <= n;i++){
            for(int j = 1;j <= n;j++){
                matrix[i][j] = min(matrix[i][j], matrix[j][i]);
            }
        }
        int cnt = n * (n + 1) / 2;
        for(int i = 1;i <= n;i++){
            for(int j = i;j <= n;j++){
                cnt--;
                if(noPath[i][j]){
                    continue;
                }
                answer(matrix[i][j], cnt);
            }
        }
        cout << ans << endl;
        return;
    }
    for(int i = 1;i <= q;i++){
        int a, b;
        cin >> a >> b;
        if(noPath[a][b]){
            continue;
        }
        for(int k = 1;k <= m;k++){
            t = false;
            memset(used, 0, sizeof(used));
            DFS(b, a, k);
            if(!t){
                matrix[a][b] = k;
                break;
            }
        }
        if(!matrix[a][b])
            matrix[a][b] = m + 1;
        for(int k = 1;k <= m;k++){
            t = false;
            memset(used, 0, sizeof(used));
            DFS(a, b, k);
            if(!t){
                matrix[b][a] = k;
                break;
            }
        }
        if(!matrix[b][a])
            matrix[b][a] = m + 1;
        answer(min(matrix[a][b], matrix[b][a]), q - i);
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    preCompute();
    solve();
    return 0;
}
