#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int64_t MAXN_2SUBTASK = 1e5 + 50;
const int64_t INF = 1e18;
struct Bus
{
    int64_t x, c;
    Bus(){}
    Bus(int64_t x, int64_t c)
        :x(x), c(c){}
};

struct Person
{
    int64_t x, v;
    Person(){}
    Person(int64_t x, int64_t v)
        :x(x), v(v){}
};

int64_t n, m, prevV;
Bus buses[MAXN_2SUBTASK];
Person people[MAXN_2SUBTASK];

void secondSubtask()
{
    //cout << "SECOND SUBTASK" << endl;
    //price for person (xi - yi)*v + ci = xi*v - yi*v + ci
    //a = -yi*v + ci
    //price for bus = xi*v + a
    //optimal price - minimal 'a'

    int64_t v = people[0].v;
    int64_t a[MAXN_2SUBTASK];

    for (int64_t i = 0; i < n; i++)
        a[i] = -buses[i].x*v + buses[i].c;

    int64_t minA = INF;
    int64_t j = 0, ans = 0;

    for (int i = 0; i < m; i++)
    {
        while (j < n && people[i].x >= buses[j].x)
        {
            minA = min(minA, a[j]);
            j++;
        }
        j--;

        ans += minA + people[i].x*v;

        cout << ans << " ";
    }

    cout << endl;

}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    bool isSecondSubtask = true;

    cin >> n;
    for (int64_t i = 0; i < n; i++)
        cin >> buses[i].x >> buses[i].c;

    cin >> m;
    cin >> people[0].x >> people[0].v;
    prevV = people[0].v;

    for (int64_t i = 1; i < m; i++)
    {
        cin >> people[i].x >> people[i].v;

        if (people[i].v != prevV)
            isSecondSubtask = false;
    }

    if (isSecondSubtask == true)
    {
        secondSubtask();
        return 0;
    }

    return 0;
}
