#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int64_t MAXN_2SUBTASK = 1e5 + 50;
const int64_t INF = 2e18 + 50;
struct Bus
{
    int64_t x, c;
    Bus(){}
    Bus(int64_t x, int64_t c)
        :x(x), c(c){}
};

struct Person
{
    int64_t x, v;
    Person(){}
    Person(int64_t x, int64_t v)
        :x(x), v(v){}
};

int64_t n, m, prevV;
Bus buses[MAXN_2SUBTASK];
Person people[MAXN_2SUBTASK];

void secondSubtask()
{
    //cout << "SECOND SUBTASK" << endl;
    //price for person (xi - yi)*v + ci = xi*v - yi*v + ci
    //a = -yi*v + ci
    //price for bus = xi*v + a
    //optimal price - minimal 'a'

    int64_t v = people[1].v;
    int64_t a[MAXN_2SUBTASK];

    for (int64_t i = 1; i <= n; i++)
        a[i] = -buses[i].x*v + buses[i].c;

    int64_t minA = INF;
    int64_t j = 1, ans = 0;

    for (int i = 1; i <= m; i++)
    {
        while (j <= n && people[i].x >= buses[j].x)
        {
            minA = min(minA, a[j]);
            j++;
        }
        j--;

        ans += minA + people[i].x*v;

        cout << ans << " ";
    }

    cout << endl;

}

const int64_t MAXN = 2e4 + 50;
const int64_t MAXM = 1e3 + 50;

int64_t dp[MAXN][MAXM]; //minimal price if the first j people go on buses from 1 to i

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    bool isSecondSubtask = true;

    cin >> n;
    for (int64_t i = 1; i <= n; i++)
        cin >> buses[i].x >> buses[i].c;

    cin >> m;
    cin >> people[1].x >> people[1].v;
    prevV = people[1].v;

    for (int64_t i = 2; i <= m; i++)
    {
        cin >> people[i].x >> people[i].v;

        if (people[i].v != prevV)
            isSecondSubtask = false;
    }

    if (isSecondSubtask == true)
    {
        secondSubtask();
        return 0;
    }

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            dp[i][j] = INF;

    for (int i = 1; i <= n; i++)
    {
        if (people[1].x < buses[i].x)
            continue;

        dp[i][1] = (people[1].x - buses[i].x)*people[1].v + buses[i].c;
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = 2; j <= m; j++)
        {
            if (people[j].x < buses[i].x)
                continue;

            for (int k = 1; k < i; k++)
                dp[i][j] = min(dp[i][j], dp[k][j-1]+buses[i].c);

            dp[i][j] = min(dp[i][j], dp[i][j-1]);
            dp[i][j] += (people[j].x - buses[i].x)*people[j].v;
        }
    }

    for (int j = 1; j <= m; j++)
    {
        int64_t ans = INF;
        for (int i = 1; i <= n; i++)
        {
            ans = min(ans, dp[i][j]);
        }

        cout << ans << " ";
    }

    cout << endl;
    return 0;
}
