#include "sorting.h"
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 500007;
ll n, m, k;
vector<ll>primes;
bool is_comp[N];

void eratosthenes(ll len = N - 1) {
	for (ll i = 2; i <= len; i++) {
		if (!is_comp[i]) {
			primes.push_back(i);
			for (ll j = i * i; j <= len; j += i) {
				is_comp[j] = true;
			}
		}
	}
}

int find_smallest() {
	int cur = 1;
	for (int i = 2; i <= n; i++) {
		if (compare(i, cur)) {
			cur = i;
		}
	}
	return cur;
}

int find_pos(int x, int sml) {
	ll pos = 1;
	for (auto pr : primes) {
		//cout << pr << " ";
		if (pos * pr >= n)break;
		ll cur = pr;
		while (pos * pr < n && divisible(x, sml, cur)) {
			pos *= pr;
			cur *= pr;
		}
	}
	//cout << endl;
	return pos;
}

vector<int> solve(int NN) {
	n = NN;
	vector<int>p(n);
	vector<int>ans(n);
	eratosthenes();
	int sml = find_smallest();
	p[0] = sml;
	for (int i = 1; i <= n; i++) {
		if (i != sml) {
			//cout << i << ": ";
			//cout << find_pos(i, sml) << endl;
			p[find_pos(i, sml)] = i;
		}
	}
	for (int i = 0; i < n; i++) {
		ans[p[i] - 1] = i + 1;
	}
	return ans;
}