#include "sorting.h"
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 500007;
ll n, m, k;
vector<ll>primes;
bool is_comp[N];
pair<int, int>poss[N];

void eratosthenes(ll len = N - 1) {
	for (ll i = 2; i <= len; i++) {
		if (!is_comp[i]) {
			primes.push_back(i);
			for (ll j = i * i; j <= len; j += i) {
				is_comp[j] = true;
			}
		}
	}
}

int find_smallest() {
	int cur = 1;
	for (int i = 2; i <= n; i++) {
		if (compare(i, cur)) {
			cur = i;
		}
	}
	return cur;
}

int find_pos(int x, int sml) {
	ll pos = 1;
	for (auto pr : primes) {
		//cout << pr << " ";
		if (pos * pr >= n)break;
		ll cur = pr;
		while (pos * pr < n && divisible(x, sml, cur)) {
			pos *= pr;
			cur *= pr;
		}
	}
	//cout << endl;
	return pos;
}

int compare_(const void* a, const void* b) {
	int x = *((int*)a);
	int y = *((int*)b);
	if (x == y)return 0;
	int vl = compare(x, y);
	if (vl) {
		return -1;
	}
	else return 1;
}

vector<int> solve(int NN) {
	n = NN;
	vector<int>p;
	vector<int>ans(n);
	if (n > 1000000) {
		for (int i = 1; i <= n; i++) {
			p.push_back(i);
		}
		qsort(&p[0], p.size(), sizeof(int), compare_);
		for (int i = 0; i < n; i++) {
			ans[p[i] - 1] = i + 1;
		}
		return ans;
	}
	p.resize(n);
	eratosthenes(n + 2);
	int sml = 1;
	int krkn = 0;
	for (int i = 1; i <= n; i++) {
		if (i != sml) {
			//cout << i << ": ";
			//cout << find_pos(i, sml) << endl;
			int vl = find_pos(i, sml);
			if (poss[vl].ff != 0) {
				poss[vl].ss = i;
				krkn++;
			}
			else {
				poss[vl].ff = i;
			}
		}
	}
	int smlpos;
	if (2ll * krkn == n - 1) {
		p[n / 2] = sml;
		smlpos = n / 2;
	}
	else {
		if (compare(poss[krkn + 1].ff, poss[1].ff)) {
			p[n - krkn - 1] = sml;
			smlpos = n - krkn - 1;
			for (int i = krkn + 1; i < n - krkn; i++) {
				p[n - krkn - i - 1] = poss[i].ff;
			}
		}
		else {
			p[krkn] = sml;
			smlpos = krkn;
			for (int i = krkn + 1; i < n - krkn; i++) {
				p[krkn + i] = poss[i].ff;
			}
		}
	}
	for (int i = 1; i <= krkn; i++) {
		int mn = poss[i].ff;
		int mx = poss[i].ss;
		if (compare(mx, mn)) {
			swap(mx, mn);
		}
		p[smlpos + i] = mx;
		p[smlpos - i] = mn;
	}
	for (int i = 0; i < n; i++) {
		ans[p[i] - 1] = i + 1;
	}
	return ans;
}