﻿#include <iostream>
#include <vector>
#include <queue>
using namespace std;

using LL = long long;

template<typename T>
using V = vector<T>;

const int N = 2000, p = 1e9 + 7, B = 2e5;
int color[N], connected[N][N];

LL binpowmod(LL a, LL n)
{
	LL ans = 1;
	while (n) {
		if (n & 1)
			ans = (ans * a) % p;
		a = (a * a) % p;
		n >>= 1;
	}
	return ans;
}

int main()
{
	int n, m, i, j, a, b, t, k;
	LL ans = 0;
	cin >> n >> m;
	V<V<int>> graph(n);
	queue<int> q;
	for (i = 0; i < m; ++i) {
		cin >> a >> b;
		graph[a - 1].push_back(b - 1);
	}
	for (i = 0; i < n; ++i) {
		for (j = 0; j < n; ++j)
			color[j] = 0;
		connected[i][i] = 1;
		color[i] = 1;
		q.push(i);
		while (!q.empty()) {
			a = q.front();
			q.pop();
			for (b = 0; b < graph[a].size(); ++b)
				if (!color[graph[a][b]]) {
					connected[graph[a][b]][i] = 1;
					color[graph[a][b]] = 1;
					q.push(graph[a][b]);
				}
		}
	}
	cin >> t;
	if (!t) {
		k = n * (n + 1) / 2;
		for (a = 0; a < n; ++a)
			for (b = a; b < n; ++b) {
				--k;
				if (connected[a][b])
					ans = (ans + ((m + 1) * binpowmod(B, k)) % p) % p;
			}
	}
	else {
		k = t;
		while (t--) {
			cin >> a >> b;
			--k;
			if (connected[a - 1][b - 1])
				ans = (ans + ((m + 1) * binpowmod(B, k)) % p) % p;
		}
	}
	cout << ans;
	return 0;
}