#include<bits/stdc++.h>
using namespace std;
using ll = long long;
struct convex_hull {
    struct line {
        __int128_t a, b;
        __int128_t x;
        line(__int128_t _a, __int128_t _b) {
            a=_a,b=_b;
        }
        __int128_t intersect(line s) {
            return (s.b-b+a-s.a-1)/(a-s.a);	
        }
        __int128 val(__int128 _x) {
            return a*_x+b;
        }
    };
    vector<line> hull;
    void insert(line l) {
        while(hull.size()) {
            line c = hull.back();
            if(c.val(c.x)>l.val(c.x)) {
                hull.pop_back();
                continue;
            }
            else if(c.a!=l.a) {
                l.x = l.intersect(c);
                hull.push_back(l);
            }

			return;
        }
        l.x=0;
        hull.push_back(l);
    }
    static bool cmp(__int128 x, line l) {
        return x<l.x;
    }
    __int128 query(__int128 x) {
        int idx = --upper_bound(hull.begin(), hull.end(),x,cmp)-hull.begin();
        return hull[idx].val(x);
    }
};

int main () {
    convex_hull cc;
    int n;
    cin >> n;
    vector<pair<ll,ll>> v(n+1);
	v[0]={0,0};
    for(int i = 1;i<=n;i++){
        cin >> v[i].first >> v[i].second;
    }
    int m;
    cin >> m;
    vector<pair<ll,ll>> p(m);
    for(int i = 0;i<m;i++)cin>>p[i].first>>p[i].second;
     __int128 ans=0;
    int at=0;
    for(int i = 0;i<m;i++) {
        for(;at<=n and v[at].first<=p[i].first;at++) {
            cc.insert(convex_hull::line(-v[at].first, v[at].second));
        }
        __int128_t res=cc.query(p[i].second)+p[i].first*p[i].second;
        ans+=res;
        ll rs=ans;
        cout << rs << " ";
    }
	cout << "\n";
}

