#include <bits/stdc++.h>

using namespace std;

#define lg long long

const lg N = 2e3+5, MOD = 1e9+7;

vector<multiset<lg>> adj(N);
lg vis[N], tmp;
lg reach[N][N];

void dfs(lg src)
{
	vis[src] = tmp;
	for(auto it : adj[src])
	{
		if(vis[it] == tmp)	continue;
		dfs(it);
	}
	return;
}

lg fast_power(lg n, lg k)
{	
	lg ans = 1;
	while(k)
	{
		if((k&1))	ans = (ans*n)%MOD;
		n = (n*n)%MOD;
		k >>= 1;
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
	lg n, m;
	cin >> n >> m;
	vector<pair<lg, lg>> edges;
	for(int i = 0; i < m; i++)
	{
		lg u, v;
		cin >> u >> v;
		edges.push_back({u, v});
		adj[u].insert(v);
	}
	for(int i = 1; i <= n; i++)
	{
		tmp++;
		dfs(i);
		for(int j = 1; j <= n; j++)
		{
			reach[i][j] = (vis[j] == tmp ? m+1 : 0);
		}
	}
	for(int i = 1; i <= n; i++)
	{
		for(int j = 1; j <= n; j++)
		{
			if((reach[i][j]^reach[j][i]))	reach[i][j] = reach[j][i] = 0;
		}
	}
	lg g = 1;
	set<lg> se[n+1];
	for(int i = 1; i <= n; i++)	for(int j = 1; j <= n; j++)	if(i != j)	se[i].insert(j);
	for(auto [u, v] : edges)
	{	
		adj[u].erase(adj[u].find(v));
		for(int j = 1; j <= n; j++)
		{
			tmp++;
			dfs(j);
			vector<lg> erased;
			for(auto k : se[j])
			{
				if(vis[k] == tmp)	continue;
				erased.push_back(k);
				reach[j][k] = reach[k][j] = min(reach[j][k], g);
			}	
			for(auto it : erased)	se[j].erase(it), se[it].erase(j);
		}
		adj[u].insert(v);
		g++;	
	}
	for(int i = 1; i <= n; i++)	reach[i][i] = m+1;
	lg q;
	cin >> q;
	if(!q)
	{
		lg ans = 0, cur = fast_power(2e5, n*(n+1)/2-1);
		lg inv = fast_power(2e5, MOD-2);
		for(int a = 1; a <= n; a++)
		{
			for(int b = a; b <= n; b++)
			{
				ans = (ans+((reach[a][b])*cur)%MOD);
				if(ans >= MOD)	ans -= MOD;
				cur = (cur*inv)%MOD;
			}
		}
		cout << ans << '\n';
		return 0;
	}
	lg ans = 0, cur = fast_power(2e5, q-1);
	lg inv = fast_power(2e5, MOD-2);
	while(q--)
	{
		lg a, b;
		cin >> a >> b;
		ans = (ans+((reach[a][b])*cur)%MOD);
		if(ans >= MOD)	ans -= MOD;
		cur = (cur*inv)%MOD;
	}
	cout << ans << '\n';
	return 0;
}