#include <bits/stdc++.h>

#define lg long long

using namespace std;

lg m, n;
const lg N = 1e5+5;

vector<lg> x(N), y(N), v(N);

struct segtree{
    lg n;
    vector<lg> seg[2];
    segtree(lg sz)
    {
        lg x = __lg(sz);
        if((1ll << x) != sz)	x++;
        n = (1ll << x);
        seg[0] = vector<lg> (2*n, 2e18);
        seg[1] = vector<lg> (2*n, 0);
    }
    void build()
    {
        for(int i = n-1; i; i--)	seg[0][i] = min(seg[0][i*2], seg[0][i*2+1]);
    }
    void update(lg node, lg low_range, lg high_range, lg low_query, lg high_query, lg val)
    {
        if(seg[1][node])
        {
            seg[0][node] += seg[1][node];
            if(low_range != high_range)
            {
                seg[1][node*2] += seg[1][node];
                seg[1][node*2+1] += seg[1][node];
            }
            seg[1][node] = 0;
        }
        if(low_range > high_query || low_query > high_range)	return;
        if(low_query <= low_range && high_range <= high_query)
        {
            seg[0][node] += val;
            if(low_range != high_range)
            {
                seg[1][node*2] += val;
                seg[1][node*2+1] += val;
            }
            return;
        }
        lg mid = (low_range+high_range)/2;
        update(node*2, low_range, mid, low_query, high_query, val);
        update(node*2+1, mid+1, high_range, low_query, high_query, val);
        seg[0][node] = min(seg[0][node*2], seg[0][node*2+1]);
        return;
    }
    lg get(lg node, lg low_range, lg high_range, lg low_query, lg high_query)
    {
        if(seg[1][node])
        {
            seg[0][node] += seg[1][node];
            if(low_range != high_range)
            {
                seg[1][node*2] += seg[1][node];
                seg[1][node*2+1] += seg[1][node];
            }
            seg[1][node] = 0;
        }
        if(low_range > high_query || low_query > high_range)	return 2e18;
        if(low_query <= low_range && high_range <= high_query)
        {
            return seg[0][node];
        }
        lg mid = (low_range+high_range)/2;
        lg l_c = get(node*2, low_range, mid, low_query, high_query);
        lg r_c = get(node*2+1, mid+1, high_range, low_query, high_query);
        seg[0][node] = min(seg[0][node*2], seg[0][node*2+1]);
        return min(l_c, r_c);
    }
};

int main()
{
    cin >> n;
    segtree s(n);
    for(int i = 0; i < n; i++)
    {
        cin >> y[i] >> s.seg[0][i+s.n];
    }
    s.build();
    cin >> m;
    for(int i = 0; i < m; i++)
    {
        cin >> x[i] >> v[i];
    }
    lg idx = 0, ans = 0, last_pos = y[0];
    for(int i = 0; i < m; i++)
    {
        while(idx+1 < n && y[idx+1] <= x[i])	
        {
            s.update(1, 1, s.n, 1, idx+1, (y[idx+1]-last_pos)*v[i]);
            last_pos = y[idx+1];
            idx++;
        }
        s.update(1, 1, s.n, 1, idx+1, (x[i]-last_pos)*v[i]);
        last_pos = x[i];
        ans += s.get(1, 1, s.n, 1, idx+1);
        /*lg cur = 2e18;
        for(int j = 0; j < n; j++)
        {
            if(y[j] > x[i])	break;
            cur = min(cur, abs(y[j]-x[i])*v[i]+s.seg[0][j+s.n]);
        }
        ans += cur;*/
        cout << ans << ' ';
    }
}