#include <vector>
#include <bits/stdc++.h>
#include "sorting.h"

#define lg long long

using namespace std;

#ifdef CYBER
#include "Lgrader.cpp"
#endif

const int N = 5e5+5;

bitset<N> primes;
vector<int> prim;

void sieve()
{
	primes.set();
	primes[0] = primes[1] = 0;
	for(lg i = 2; i < N; i++)
	{
		if(!primes[i])	continue;
		prim.push_back(i);
		for(lg j = 1ll*i*i; j < N; j += i)
		{
			primes[j] = false;
		}
	}
	return;
}


int fast_power(lg n, int k)
{
	int ans = 1, flag = 0;
	while(k)
	{
		if((k&1))	
		{
			if(flag)	return 5e5+1;
			ans = (ans*n);
			if(ans > 5e5)	return 5e5+1;
		}
		n = (n*n);
		k >>= 1;
		if(n > 5e5)	flag = true;
	}
	return ans;
}

vector<int> d_c(int l, int r, int &n)
{
	if(r == l)	return {0};
	int mid = (r-l)/2;
	vector<int> ans = d_c(l, mid+l, n);
	vector<int> b = d_c(l+mid+1, r, n);
	int mxm = 1;
	for(int i = 1; i*2 <= n; i++)
	{
		if(divisible(l+1, l+mid+2, n-i))	
		{
			mxm = n-i;
			continue;
		}
		if(divisible(l+1, l+mid+2, i))	mxm = i;
	}
	if(compare(l+1, l+mid+2))	
	{
		for(int i = 0; i < b.size(); i++)	ans.push_back(b[i]+mxm);
	}
	else	
	{
		for(int i = 0; i < b.size(); i++)	ans.push_back(b[i]-mxm);
	}
	return ans;
}

std::vector < int > solve(int n)
{
	sieve();
	vector<int> ans = d_c(0, n-1, n);
	int l = 1, r = n;
	for(int j = 1; j < n; j++)
	{
		l = max(l , 1-ans[j]);
		r = min(r , n-ans[j]);
	}	
	for(auto &it : ans)	it += l;
	return ans;
}