#include <bits/stdc++.h>
#include "sorting.h"

#define lg long long

using namespace std;

#ifdef CYBER
#include "Lgrader.cpp"
#endif

const int M = 5e5+5;
int N = 5e5+5;

bitset<M> primes;
vector<int> prim;

void sieve(int &n)
{
    primes.set();
    primes[0] = primes[1] = 0;
    for(lg i = 2; i <= n; i++)
    {
        if(!primes[i])	continue;
        prim.push_back(i);
        for(lg j = 1ll*i*i; j <= n; j += i)
        {
            primes[j] = false;
        }
    }
    return;
}


int fast_power(lg n, int k)
{
    int ans = 1, flag = 0;
    while(k)
    {
        if((k&1))	
        {
            if(flag)	return N+1;
            ans = (ans*n);
            if(ans > N)	return N+1;
        }
        n = (n*n);
        k >>= 1;
        if(n > N)	flag = true;
    }
    return ans;
}

vector<int> d_c(int l, int r, int &n)
{
    if(r == l)	return {0};
    int mid = (r-l)/2;
    vector<int> ans = d_c(l, mid+l, n);
    vector<int> b = d_c(l+mid+1, r, n);
    lg mxm = 1;
    for(auto it : prim)
    {
	if(mxm*it > n)	break;
	while(mxm*it <= n)
	{
		if(divisible(l+1, l+mid+2, mxm*it))	mxm *= it;
		else	break;
	}
    }
    if(compare(l+1, l+mid+2))	
    {
        for(int i = 0; i < b.size(); i++)	ans.push_back(b[i]+mxm);
    }
    else	
    {
        for(int i = 0; i < b.size(); i++)	ans.push_back(b[i]-mxm);
    }
    return ans;
}

std::vector < int > solve(int n)
{
    N = n+2;
    sieve(n);
    vector<int> ans = d_c(0, n-1, n);
    int l = 1, r = n;
    for(int j = 1; j < n; j++)
    {
        l = max(l , 1-ans[j]);
        r = min(r , n-ans[j]);
    }	
    for(auto &it : ans)	it += l;
    return ans;
}