#include "bits/stdc++.h"
using namespace std;

struct edge {
    int i;
    int v;

    edge(int i, int v) : i(i), v(v) {}
};

int n, m;
vector<vector<edge>> g;
const long long B = 200000;
const long long mod = (long long)1e9 + 7;
const int N = 10000000;
long long power[N + 1] = {};


bool reachable(int u, int v, int i) {
    vector<bool> used(n + 1, false);
    queue<int> q;

    used[u] = true;
    q.push(u);

    while (!q.empty()) {
        int x = q.front();
        q.pop();

        for (auto to : g[x]) {
            if (to.i == i) {
                continue;
            }

            if (!used[to.v]) {
                used[to.v] = true;
                q.push(to.v);
            }
        }
    }

    return used[v];
}

void solve() {
    power[0] = 1;
    for (int i = 1; i <= N; i++) {
        power[i] = power[i - 1] * B % mod;
    }

    cin >> n >> m;

    g.assign(n + 1, vector<edge> ());

    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(i, v);
    }

    int q;
    cin >> q;
    int k = q;
    vector<long long> s;
    s.reserve(q);
    while (q--) {
        int u, v;
        cin >> u >> v;

        if (!reachable(u, v, 0) || !reachable(v, u, 0)) {
            s.emplace_back(0);
            continue;
        }

        bool r = true;
        for (int i = 1; i <= m; i++) {
            if (!reachable(u, v, i) || !reachable(v, u, i)) {
                s.emplace_back(i);
                r = false;
                break;
            }
        }

        if (r) {
            s.emplace_back(m + 1);
        }
    }

    long long ans = 0;
    for (int i = 0; i < k; i++) {
        ans = (ans + s[i] * power[k - 1 - i]) % mod;
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}