#include "bits/stdc++.h"
using namespace std;

vector<vector<int>> g;
vector<vector<int>> r;

vector<int> order;
vector<bool> topsort_used;
void topsort(int v) {
    topsort_used[v] = true;
    for (auto to : g[v]) {
        if (!topsort_used[to]) {
            topsort(to);
        }
    }
    order.push_back(v);
}

vector<int> color;
void mark(int v, int c) {
    color[v] = c;
    for (auto to : r[v]) {
        if (!color[to]) {
            mark(to, c);
        }
    }
}

const long long B = 200000;
const long long mod = (long long)1e9 + 7;

const int N = 2000 * 2000;
long long power[N + 1] = {};

void solve() {
    power[0] = 1;
    for (int i = 1; i <= N; i++) {
        power[i] = power[i - 1] * B % mod;
    }

    int n, m;
    cin >> n >> m;

    g.assign(n + 1, vector<int> ());
    r.assign(n + 1, vector<int> ());
    order.reserve(n + 1);
    topsort_used.assign(n + 1, false);
    color.assign(n + 1, 0);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        r[v].push_back(u);
    }

    for (int i = 1; i <= n; i++) {
        if (!topsort_used[i]) {
            topsort(i);
        }
    }

    reverse(order.begin(), order.end());
    int curc = 1;
    for (int i : order) {
        if (!color[i]) {
            mark(i, curc);
            curc++;
        }
    }

    int q;
    cin >> q;

    vector<long long> s;
    long long k;
    if (q == 0) {
        k = n * (n + 1) / 2;
        s.reserve(k);
        for (int u = 1; u <= n; u++) {
            for (int v = u; v <= n; v++) {
                if (color[u] != color[v]) {
                    s.push_back(0ll);
                } else {
                    s.push_back((long long)m + 1);
                }
            }
        }
    } else {
        k = q;
        s.reserve(k);
        while (q--) {
            int u, v;
            cin >> u >> v;

            if (color[u] != color[v]) {
                s.push_back(0ll);
            } else {
                s.push_back((long long)m + 1);
            }
        }
    }

    long long ans = 0;
    for (int i = 0; i < k; i++) {
        ans += (s[i] * power[k - 1 - i]) % mod;
        ans %= mod;
    }

    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}