#include "bits/stdc++.h"
using namespace std;

struct edge {
    int i;
    int v;

    edge(int i, int v) : i(i), v(v) {}
};

int n, m;
vector<vector<edge>> g;
const long long B = 200000;
const long long mod = (long long)1e9 + 7;
const int N = 10000000;
long long power[N + 1] = {};


bool reachable(int u, int v, int i) {
    vector<bool> used(n + 1, false);
    queue<int> q;

    used[u] = true;
    q.push(u);

    while (!q.empty()) {
        int x = q.front();
        q.pop();

        for (auto to : g[x]) {
            if (to.i == i) {
                continue;
            }

            if (!used[to.v]) {
                used[to.v] = true;
                q.push(to.v);
            }
        }
    }

    return used[v];
}

vector<vector<int>> gd;
vector<vector<int>> gr;

vector<int> order;
vector<bool> topsort_used;
void topsort(int v) {
    topsort_used[v] = true;
    for (auto to : gd[v]) {
        if (!topsort_used[to]) {
            topsort(to);
        }
    }
    order.push_back(v);
}

vector<int> color;
void mark(int v, int c) {
    color[v] = c;
    for (auto to : gr[v]) {
        if (!color[to]) {
            mark(to, c);
        }
    }
}

void hard() {
    power[0] = 1;
    for (int i = 1; i <= N; i++) {
        power[i] = power[i - 1] * B % mod;
    }

    cin >> n >> m;

    gd.assign(n + 1, vector<int> ());
    gr.assign(n + 1, vector<int> ());
    order.reserve(n + 1);
    topsort_used.assign(n + 1, false);
    color.assign(n + 1, 0);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        gd[u].push_back(v);
        gr[v].push_back(u);
    }

    for (int i = 1; i <= n; i++) {
        if (!topsort_used[i]) {
            topsort(i);
        }
    }

    reverse(order.begin(), order.end());
    int curc = 1;
    for (int i : order) {
        if (!color[i]) {
            mark(i, curc);
            curc++;
        }
    }

    int q;
    cin >> q;

    vector<long long> s;
    long long k;
    if (q == 0) {
        k = n * (n + 1) / 2;
        s.reserve(k);
        for (int u = 1; u <= n; u++) {
            for (int v = u; v <= n; v++) {
                if (color[u] != color[v]) {
                    s.push_back(0ll);
                } else {
                    s.push_back((long long)m + 1);
                }
            }
        }
    } else {
        k = q;
        s.reserve(k);
        while (q--) {
            int u, v;
            cin >> u >> v;

            if (color[u] != color[v]) {
                s.push_back(0ll);
            } else {
                s.push_back((long long)m + 1);
            }
        }
    }

    long long ans = 0;
    for (int i = 0; i < k; i++) {
        ans += (s[i] * power[k - 1 - i]) % mod;
        ans %= mod;
    }

    cout << ans << "\n";
}

void easy() {
    power[0] = 1;
    for (int i = 1; i <= N; i++) {
        power[i] = power[i - 1] * B % mod;
    }

    g.assign(n + 1, vector<edge> ());

    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(i, v);
    }

    int q;
    cin >> q;

    if (q == 0) {
        int k = n * (n + 1) / 2;
        vector<long long> s;
        s.reserve(k);

        for (int u = 1; u <= n; u++) {
            for (int v = u; v <= n; v++) {
                if (u == v) {
                    s.emplace_back(m + 1);
                    continue;
                }

                if (!reachable(u, v, 0) || !reachable(v, u, 0)) {
                    s.emplace_back(0);
                    continue;
                }

                bool r = true;
                for (int i = 1; i <= m; i++) {
                    if (!reachable(u, v, i) || !reachable(v, u, i)) {
                        s.emplace_back(i);
                        r = false;
                        break;
                    }
                }

                if (r) {
                    s.emplace_back(m + 1);
                }
            }
        }

        long long ans = 0;
        for (int i = 0; i < k; i++) {
            ans = (ans + s[i] * power[k - 1 - i]) % mod;
        }
        cout << ans << "\n";
        return;
    }

    int k = q;
    vector<long long> s;
    s.reserve(q);
    while (q--) {
        int u, v;
        cin >> u >> v;

        if (!reachable(u, v, 0) || !reachable(v, u, 0)) {
            s.emplace_back(0);
            continue;
        }

        bool r = true;
        for (int i = 1; i <= m; i++) {
            if (!reachable(u, v, i) || !reachable(v, u, i)) {
                s.emplace_back(i);
                r = false;
                break;
            }
        }

        if (r) {
            s.emplace_back(m + 1);
        }
    }

    long long ans = 0;
    for (int i = 0; i < k; i++) {
        ans = (ans + s[i] * power[k - 1 - i]) % mod;
    }
    cout << ans << "\n";
}

void solve() {
    cin >> n >> m;

    if (n <= 200 && m <= 1000) {
        easy();
    } else {
        hard();
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}