﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
ll n, m;
vector<vector<pair<ll, ll>>> g, rg;
ll zap = -1;
void topsort(ll v, vector<ll>& t, vector<bool>& used) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (i.second != zap && !used[i.first]) {
            topsort(i.first, t, used);
        }
    }
    t.push_back(v);
}

void dfs(ll v, vector<ll>& ans, ll k) {
    ans[v] = k;
    for (auto i : rg[v]) {
        if (i.second != zap && ans[i.first] == -1) {
            dfs(i.first, ans, k);
        }
    }
}

vector<ll> komp(ll zp) {
    zap = zp;
    vector<ll> ans(n, -1), t;
    vector<bool> used(n, 0);
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            topsort(i, t, used);
        }
    }
    reverse(all(t));
    ll k = 0;
    for (ll i = 0; i < n; i++) {
        if (ans[t[i]] == -1) {
            dfs(t[i], ans, k);
            k++;
        }
    }
    return ans;
}

void solve1() {
    /*vector<vector<ll>> k(m);
    for (ll i = 0; i < m; i++) {
        if (i == 3) {
            ll aboba = 0;
        }
        k[i] = komp(i);
    }*/
    vector<ll> kk = komp(-1);
    ll q;
    cin >> q;
    ll B = 2e5, K = q, MOD = 1e9 + 7;
    if (q == 0)  K = n * (n + 1) / 2;
    vector<ll> stp(K, 1);
    for (ll i = 1; i < K; i++) {
        stp[i] = ((long long)stp[i - 1] * B) % MOD;
    }
    ll ans = 0;
    if (q > 0) {
        forr(kkk, K) {
            ll u, v;
            cin >> u >> v;
            u--; v--;
            ll res = 0;
            if (kk[u] != kk[v]) {
                res = 0;
            } else {
                bool b = 1;
                /*forr(i, m) {
                    if (k[i][u] != k[i][v]) {
                        res = i + 1;
                        b = 0;
                        break;
                    }
                }*/
                if (b) res = m + 1;
            }
            ans = ((long long)res * stp[K - kkk - 1] + ans) % MOD;
        }
    } else {
        ll ind = 0;
        for (ll i = 0; i < n; i++) {
            for (ll j = i; j < n; j++) {
                ll u = i, v = j;
                ll res = 0;
                if (kk[u] != kk[v]) {
                    res = 0;
                } else {
                    bool b = 1;
                    /*forr(i, m) {
                        if (k[i][u] != k[i][v]) {
                            res = i + 1;
                            b = 0;
                            break;
                        }
                    }*/
                    if (b) res = m + 1;
                }
                if (i == 1 && j == 5) {
                    ll aboba = 0;
                }
                ans = ((long long)res * stp[K - ind - 1] + ans) % MOD;
                ind++;

            }
        }
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    g.resize(n);
    rg.resize(n);
    forr(i, m) {
        ll u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back({v, i});
        rg[v].push_back({u, i});
    }
    if (n <= 2000 && m <= 8000) {
        vector<vector<ll>> k(m);
        for (ll i = 0; i < m; i++) {
            if (i == 3) {
                ll aboba = 0;
            }
            k[i] = komp(i);
        }
        vector<ll> kk = komp(-1);
        ll q;
        cin >> q;
        ll B = 2e5, K = q, MOD = 1e9 + 7;
        if (q == 0)  K = n * (n + 1) / 2;
        vector<ll> stp(K, 1);
        for (ll i = 1; i < K; i++) {
            stp[i] = ((long long)stp[i - 1] * B) % MOD;
        }
        ll ans = 0;
        if (q > 0) {
            forr(kkk, K) {
                ll u, v;
                cin >> u >> v;
                u--; v--;
                ll res = 0;
                if (kk[u] != kk[v]) {
                    res = 0;
                } else {
                    bool b = 1;
                    forr(i, m) {
                        if (k[i][u] != k[i][v]) {
                            res = i + 1;
                            b = 0;
                            break;
                        }
                    }
                    if (b) res = m + 1;
                }
                ans = ((long long)res * stp[K - kkk - 1] + ans) % MOD;
            }
        } else {
            ll ind = 0;
            for (ll i = 0; i < n; i++) {
                for (ll j = i; j < n; j++) {
                    ll u = i, v = j;
                    ll res = 0;
                    if (kk[u] != kk[v]) {
                        res = 0;
                    } else {
                        bool b = 1;
                        forr(i, m) {
                            if (k[i][u] != k[i][v]) {
                                res = i + 1;
                                b = 0;
                                break;
                            }
                        }
                        if (b) res = m + 1;
                    }
                    if (i == 1 && j == 5) {
                        ll aboba = 0;
                    }
                    ans = ((long long)res * stp[K - ind - 1] + ans) % MOD;
                    ind++;

                }
            }
        }
        cout << ans << "\n";
    } else {
        solve1();
    }
    return 0;
}
