﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
const ll INF = 4e18;
const ll MAXN = (1 << 30);
struct A {
    ll x, c;
    bool operator<(const A& other) const {
        return x < other.x;
    }
};

struct Lichao {
    struct Line {
        ll a, b;
        ll get(ll x) {
            return a * x + b;
        }
    };
    struct Node {
        Line f;
        ll l, r;
        Node* lef, * rig;
        Node(Line f, ll l, ll r) : f(f), l(l), r(r), lef(nullptr), rig(nullptr) {}
    };
    Node* root = nullptr;
    void add1(Node* v, Line g) {
        ll l = v->l, r = v->r;
        Line f = v->f;
        if (f.get(l) > g.get(l)) swap(f, g);
        if (f.get(r) < g.get(r)) {
            v->f = f;
            return;
        }
        ll m = (l + r) / 2;
        if (f.get(m) < g.get(m)) {
            v->f = f;
            if (v->rig == nullptr) v->rig = new Node(g, m, r);
            else add1(v->rig, g);
        } else {
            swap(f, g);
            v->f = f;
            if (v->lef == nullptr) v->lef = new Node(g, l, m);
            else add1(v->lef, g);
        }
    }
    void add(ll a, ll b) {
        if (root == nullptr) root = new Node({a, b}, 0, (1 << 30));
        else {
            add1(root, {a, b});
        }
    }
    ll get(Node* v, ll x) {
        if (v == nullptr) return INF;
        ll l = v->l, r = v->r;
        ll ans = v->f.get(x);
        ll m = (l + r) / 2;
        if (x < m) return min(ans, get(v->lef, x));
        else return min(ans, get(v->rig, x));
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll m;
    cin >> m;
    vector<A> a(m);
    for (ll i = 0; i < m; i++) {
        cin >> a[i].x >> a[i].c;
    }
    ll n;
    cin >> n;
    vector<ll> x(n), v(n), pv(n + 1, 0);
    vector<ll> pvx(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        cin >> x[i] >> v[i];
        pvx[i + 1] = pvx[i] + x[i] * v[i];
        pv[i + 1] = pv[i] + v[i];
    }
    vector<ll> dp(n + 1, INF);
    vector<ll> kk(a.size());
    for (ll i = 0; i < a.size(); i++) {
        kk[i] = lower_bound(all(x), a[i].x) - x.begin();
    }
    dp[0] = 0;
    Lichao l;
    l.add(-pv[0], dp[0] - pvx[0]);
    for (ll i = 1; i <= n; i++) {
        for (ll j = 0; j < a.size() && a[j].x <= x[i-1]; j++) {
            for (ll k = kk[j]; k < i; k++) {
                ll x = (ll)dp[k] + a[j].c + (pvx[i] - pvx[k]) - (ll)a[j].x * (pv[i] - pv[k]);
                dp[i] = min((ll)dp[i], x);
            }
            ll k = l.get(l.root, a[j].x) + pvx[i] + pv[i] * a[j].x + a[j].c;
        }
        l.add(-pv[i], dp[i] - pvx[i]);
        cout << dp[i] << " ";
    }
    return 0;
}