﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>
#include "sorting.h"
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)

//const ll INF = 4e18;
ll n;
vector<vector<ll>> bp;
vector<char> isp;
void precalc() {
    isp.resize(n, 1);
    for (ll i = 2; i < n; i++) {
        if (isp[i]) {
            bp.push_back({i});
            while ((long long)bp.back().back() * i < n) {
                bp.back().push_back(bp.back().back() * i);
            }
            for (ll j = i * 2; j < n; j += i) {
                isp[j] = 0;
            }
        }
    }
}
vector<ll> get(vector<ll> a, ll k) {
    if (a.size() == 0) return {};
    if (a.size() == 1) return {0};
    ll mn = a[0];
    for (ll i : a) {
        if (i != mn && compare(i + 1, mn + 1)) mn = i;
    }
    vector<ll> b, c;
    for (ll i : a) {
        if (divisible(i + 1, mn + 1, min(n, (1 << (k + 1))))) {
            b.push_back(i);
        } else {
            c.push_back(i);
        }
    }
    vector<ll> d = get(b, k + 1), e = get(c, k + 1);
    vector<ll> ans;
    ll ib = 0, ic = 0;
    for (ll i : a) {
        if (divisible(i + 1, mn + 1, min(n, (1 << (k + 1))))) {
            ans.push_back((d[ib] << 1));
            ib++;
        } else {
            ans.push_back((e[ic] << 1) + 1);
            ic++;
        }
    }
    return ans;
}

vector<int> solve(ll nn) {
    n = nn;
    if (n <= 10000) {
        precalc();
        ll mn = 0;
        vector<ll> ans(n);
        vector<pair<ll, ll>> pos(n, {-1, -1});
        for (ll i = 0; i < n; i++) {
            if (i != mn) {
                ans[i] = 1;
                forr(j, bp.size()) {
                    forr(k, bp[j].size()) {
                        if (divisible(i + 1, mn + 1, bp[j][k])) ans[i] *= bp[j][0];
                        else break;
                    }
                }
                if (pos[ans[i]].first == -1) pos[ans[i]].first = i;
                else pos[ans[i]].second = i;

            } else ans[i] = 0, pos[0].first = i;
        }
        ll mx = 0;
        for (ll i = 0; i < n; i++) {
            if (pos[i].second != -1) {
                mx = max(mx, i);
            }
        }
        if (mx == 0) {
            if (compare(mn + 1, mn + 2)) {
                forr(i, n) ans[i]++;
                return ans;
            } else {
                forr(i, n) ans[i] = n - ans[i];
                return ans;
            }
        }
        ll zmn = 0;
        for (ll i = 0; i < n; i++) {
            if (pos[i].second != -1 && i == mx) {
                if (pos[i + 1].first == -1) zmn = (n + 1) / 2;
                else {
                    if (compare(pos[i].second + 1, pos[i + 1].first + 1)) {
                        zmn = i + 1;
                    } else {
                        zmn = n - i;
                    }
                }
            }
        }
        for (ll i = 0; i < n; i++) {
            if (pos[i].second != -1) {
                if (compare(pos[i].first + 1, pos[i].second + 1)) {
                    ans[pos[i].first] = zmn - i;
                    ans[pos[i].second] = zmn + i;
                } else {
                    ans[pos[i].first] = zmn + i;
                    ans[pos[i].second] = zmn - i;
                }
            } else if (pos[i].first != -1) {
                if (zmn - i >= 1) ans[pos[i].first] = zmn - i;
                else ans[pos[i].first] = zmn + i;
            }
        }
        return ans;
    } else {
        vector<ll> a(n);
        forr(i, n) a[i] = i;
        vector<ll> ans = get(a, 0);
        forr(i, n) ans[i] = ans[i] + 1;
        return ans;
    }
}

/*const int __MAXN = 500000 + 10;

int __compareCnt;
int __n, __p[__MAXN];
bool compare(int x, int y) {
    __compareCnt++;
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n)) {
        std::cerr << "Invalid compare query!\n";
        exit(0);
    }

    return __p[x] < __p[y];
}

bool divisible(int x, int y, int d) {
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n && 1 <= d && d <= __n)) {
        std::cerr << "Invalid divisible query!\n";
        exit(0);
    }

    return abs(__p[x] - __p[y]) % d == 0;
}

void read() {
    std::cin >> __n;
    for (int i = 1; i <= __n; ++i) {
        std::cin >> __p[i];
    }
}

double score() {
    int logn = 0;
    while ((1 << logn) < __n) ++logn;
    if (__compareCnt <= __n / 2) return 1.;
    if (__compareCnt <= 2 * __n / 2) return 0.7;
    if (__compareCnt <= 2 * __n) return 0.5;
    if (__compareCnt <= __n * logn) return 0.15;
    if (__compareCnt <= __n * (1 + logn)) return 0.1;
    return 0.05;
}

void fastIO() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

int main() {
    // fastIO();
    read();

    std::vector < int > res = solve(__n);
    if (res.size() != __n) {
        std::cout << "Invalid result! WA!\n";
        exit(0);
    }

    for (int i = 1; i <= __n; ++i) {
        if (res[i - 1] != __p[i]) {
            std::cout << "Incorrect element! WA!\n";
            exit(0);
        }
    }

    std::cout << "Correct!: " << score() << "%\n";
    return 0;
}*/