#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(time(0));

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll MOD = 1000000007, B = 200000;

void dfs(ll v, vector<ll>& color, vector<vector<ll>>& arr, ll c, vector<ll>& ts) {
	color[v] = c;
	ts.push_back(v);
	for (auto i : arr[v]) {
		if (color[i] == -1) {
			dfs(i, color, arr, c, ts);
		}
	}
}

void dfs2(ll v, vector<ll>& color, vector<ll>& old_color, vector<vector<ll>>& arr, ll c) {
	color[v] = c;
	for (auto i : arr[v]) {
		if (color[i] == -1 && old_color[v] == old_color[i]) {
			dfs2(i, color, old_color, arr, c);
		}
	}
}

vector<ll> CSS(ll n, vector<vector<ll>>& arr) {
	vector<ll> color(n, -1), color2(n, -1), ts;
	ll c = 0;
	for (ll i = 0; i < n; i++) {
		if (color[i] == -1) {
			dfs(i, color, arr, c, ts);
			c++;
		}
	}
	reverse(ts.begin(), ts.end());
	c = 0;
	for (auto i : ts) {
		if (color2[i] == -1) {
			dfs2(i, color, color2, arr, c);
			c++;
		}
	}
	return color2;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<vector<ll>> arr(n);
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		arr[a].push_back(b);
	}
	vector<ll> color = CSS(n, arr);
	vector<ll> powb(1, 1);
	for (ll i = 1; i < n * (n + 1) / 2; i++) {
		powb.push_back(powb.back() * B % MOD);
	}
	ll q;
	cin >> q;
	if (q == 0) {
		ll ans = 0, last = n * (n + 1) / 2;
		for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < n; j++) {
				last--;
				if (color[i] == color[j]) {
					ans += powb[last] * (m + 1) % MOD;
					ans %= MOD;
				}
			}
		}
		cout << ans << '\n';
		return;
	} else {
		ll ans = 0, last = q;
		for (ll i = 0; i < q; i++) {
			ll a, b;
			cin >> a >> b;
			a--;
			b--;
			last--;
			if (color[a] == color[b]) {
				ans += powb[last] * (m + 1) % MOD;
				ans %= MOD;
			}
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
