#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(time(0));

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll MOD = 1000000007, B = 200000;

void dfs(ll v, vector<ll>& color, vector<vector<pair<ll, ll>>>& arr, ll c, vector<ll>& ts, ll nb) {
	color[v] = c;
	for (auto[i, num] : arr[v]) {
		if (num == nb) {
			continue;
		}
		if (color[i] == -1) {
			dfs(i, color, arr, c, ts, nb);
		}
	}
	ts.push_back(v);
}

void dfs2(ll v, vector<ll>& color, vector<ll>& old_color, vector<vector<pair<ll, ll>>>& arr, ll c, ll nb) {
	color[v] = c;
	for (auto[i, num] : arr[v]) {
		if (num == nb) {
			continue;
		}
		if (color[i] == -1 && old_color[v] == old_color[i]) {
			dfs2(i, color, old_color, arr, c, nb);
		}
	}
}

vector<ll> CSS(ll n, vector<vector<pair<ll, ll>>>& arr, vector<vector<pair<ll, ll>>>& rarr, ll nb) {
	vector<ll> color(n, -1), color2(n, -1), ts;
	ll c = 0;
	for (ll i = 0; i < n; i++) {
		if (color[i] == -1) {
			dfs(i, color, arr, c, ts, nb);
			c++;
		}
	}
	reverse(ts.begin(), ts.end());
	c = 0;
	for (auto i : ts) {
		if (color2[i] == -1) {
			dfs2(i, color2, color, rarr, c, nb);
			c++;
		}
	}
	return color2;
}

void dfs3(ll v, vector<bool>& used, vector<bool>& np, vector<ll>& color, vector<vector<pair<ll, ll>>>& arr, vector<ll>& di) {
	used[v] = true;
	np[v] = true;
	for (auto[i, num] : arr[v]) {
		if (color[i] == color[v]) {
			//if (!used[i] || np[i]) {
			di.push_back(num);
			//}
			if (!used[i]) {
				dfs3(i, used, np, color, arr, di);
			}
		}
	}
	np[v] = false;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<vector<pair<ll, ll>>> arr(n);
	vector<ll> di;
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		//di.push_back(i + 1);
		arr[a].emplace_back(b, i + 1);
	}
	vector<vector<pair<ll, ll>>> rarr(n);
	for (ll i = 0; i < n; i++) {
		for (auto[j, num] : arr[i]) {
			rarr[j].emplace_back(i, num);
		}
	}
	vector<ll> color = CSS(n, arr, rarr, -1);
	vector<bool> used(n, false);
	vector<bool> np(n, false);
	for (ll i = 0; i < n; i++) {
		if (!used[i]) {
			dfs3(i, used, np, color, arr, di);
		}
	}
	vector<vector<ll>> dcol;
	vector<vector<bitset<500>>> sets;
	sort(di.begin(), di.end());
	for (auto i : di) {
		dcol.push_back(CSS(n, arr, rarr, i));
	}
	//for (auto i : color) {
	//	cout << i << ' ';
	//}
	//cout << '\n';
	vector<ll> powb(1, 1);
	for (ll i = 1; i < n * (n + 1) / 2; i++) {
		powb.push_back(powb.back() * B % MOD);
	}
	ll q;
	cin >> q;
	if (q == 0) {
		ll ans = 0, last = n * (n + 1) / 2;
		for (ll i = 0; i < n; i++) {
			for (ll j = i; j < n; j++) {
				last--;
				if (color[i] == color[j]) {
					bool f = false;
					if (n <= 500 && m <= 8000) {
						for (ll k = 0; k < dcol.size(); k++) {
							if (dcol[k][i] != dcol[k][j]) {
								f = true;
								ans += powb[last] * di[k] % MOD;
								ans %= MOD;
								break;
							}
						}
					}
					if (!f) {
						ans += powb[last] * (m + 1) % MOD;
						ans %= MOD;
					}
				}
			}
		}
		cout << ans << '\n';
		return;
	} else {
		ll ans = 0, last = q;
		for (ll i = 0; i < q; i++) {
			ll a, b;
			cin >> a >> b;
			a--;
			b--;
			last--;
			if (color[a] == color[b]) {
				bool f = false;
				if (n <= 500 && m <= 8000) {
					for (ll j = 0; j < dcol.size(); j++) {
						if (dcol[j][a] != dcol[j][b]) {
							f = true;
							ans += powb[last] * di[j] % MOD;
							ans %= MOD;
							break;
						}
					}
				}
				if (!f) {
					ans += powb[last] * (m + 1) % MOD;
					ans %= MOD;
				}
			}
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
