#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll>> g, gr;
vector<ll> ts;
vector<bool> used;
vector<ll> color;

void dfs(ll v) {
    used[v] = true;

    for (auto &to: g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }

    ts.push_back(v);
}

void dfs1(ll v, ll col) {
    color[v] = col;

    for (auto &to: gr[v]) {
        if (color[to] == -1) {
            dfs1(to, col);
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    g.assign(n, {});
    gr.assign(n, {});
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }

    used.assign(n, false);

    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }

    reverse(ts.begin(), ts.end());

    color.assign(n, -1);

    ll col = 0;

    for (auto &to: ts) {
        if (color[to] == -1) {
            dfs1(to, col);
            col++;
        }
    }

    ll q;
    cin >> q;
    vector<ll> s;
    if (q == 0) {
        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if (color[i] == color[j]) {
                    s.push_back(m + 1);
                } else {
                    s.push_back(0);
                }
            }
        }
    } else {
        while (q--) {
            ll a, b;
            cin >> a >> b;
            a--;
            b--;
            if (color[a] == color[b]) {
                s.push_back(m + 1);
            } else {
                s.push_back(0);
            }
        }
    }
    ll ans = 0;
    ll B = 2e5, b = 2e5;
    ll mod = 1e9 + 7;
    for (ll i = s.size(); i >= 0; i--) {
        ans = (ans + B * s[i]) % mod;
        B *= b;
    }
    cout << ans;
}