#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> ts;
vector<bool> used;
vector<vector<ll>> color;

void dfs(ll v, vector<vector<ll>> &g) {
    used[v] = true;

    for (auto &to: g[v]) {
        if (!used[to]) {
            dfs(to, g);
        }
    }

    ts.push_back(v);
}

void dfs1(ll v, ll col, ll i, vector<vector<ll>> &g) {
    color[i][v] = col;

    for (auto &to: g[v]) {
        if (color[i][to] == -1) {
            dfs1(to, col, i, g);
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;

    if (n <= 200 && m <= 1000) {
        vector<vector<vector<ll>>> g(m + 1, vector<vector<ll>>(n)), gr(m + 1, vector<vector<ll>>(n));
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            for (ll j = 0; j < m; j++) {
                if (j != i) {
                    g[j][u - 1].push_back(v - 1);
                    gr[j][v - 1].push_back(u - 1);
                }
            }
            g[m][u - 1].push_back(v - 1);
            gr[m][v - 1].push_back(u - 1);
        }

        color.assign(m + 1, vector<ll>(n, -1));

        for (ll j = 0; j <= m; j++) {
            used.assign(n, false);
            ts.clear();

            for (ll i = 0; i < n; i++) {
                if (!used[i]) {
                    dfs(i, g[j]);
                }
            }

            reverse(ts.begin(), ts.end());

            ll col = 0;

            for (auto &to: ts) {
                if (color[j][to] == -1) {
                    dfs1(to, col, j, gr[j]);
                    col++;
                }
            }
        }


        ll q;
        cin >> q;
        vector<ll> s;
        while (q--) {
            ll a, b;
            cin >> a >> b;
            a--;
            b--;
            if (color[m][a] != color[m][b]) {
                s.push_back(0);
            } else {
                bool z = false;
                for (ll i = 0; i < m; i++) {
                    if (color[i][a] != color[i][b]) {
                        s.push_back(i + 1);
                        z = true;
                        break;
                    }
                }
                if (!z) {
                    s.push_back(m + 1);
                }
            }
        }
        ll ans = 0;
        ll B = 1, b = 2e5;
        ll mod = 1e9 + 7;
        for (ll i = s.size() - 1; i >= 0; i--) {
            ans = (ans + B * s[i]) % mod;
            B = (B * b) % mod;
        }
        cout << ans;
    } else {
        vector<vector<ll>> g(n), gr(n);
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            g[u - 1].push_back(v - 1);
            gr[v - 1].push_back(u - 1);
        }

        used.assign(n, false);

        for (ll i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i, g);
            }
        }

        reverse(ts.begin(), ts.end());

        color.assign(0, vector<ll>(n, -1));

        ll col = 0;

        for (auto &to: ts) {
            if (color[0][to] == -1) {
                dfs1(to, col, 0, gr);
                col++;
            }
        }

        ll q;
        cin >> q;
        vector<ll> s;
        if (q == 0) {
            for (ll i = 0; i < n; i++) {
                for (ll j = i; j < n; j++) {
                    if (color[0][i] == color[0][j]) {
                        s.push_back(m + 1);
                    } else {
                        s.push_back(0);
                    }
                }
            }
        } else {
            while (q--) {
                ll a, b;
                cin >> a >> b;
                a--;
                b--;
                if (color[a] == color[b]) {
                    s.push_back(m + 1);
                } else {
                    s.push_back(0);
                }
            }
        }
        ll ans = 0;
        ll B = 1, b = 2e5;
        ll mod = 1e9 + 7;
        for (ll i = s.size() - 1; i >= 0; i--) {
            ans = (ans + B * s[i]) % mod;
            B = (B * b) % mod;
        }
        cout << ans;
    }
}