#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> ts;
vector<bool> used;
vector<vector<ll>> color;

void dfs(ll v, vector<vector<ll>> &g) {
    used[v] = true;

    for (auto &to: g[v]) {
        if (!used[to]) {
            dfs(to, g);
        }
    }

    ts.push_back(v);
}

void dfs1(ll v, ll col, ll i, vector<vector<ll>> &g) {
    color[i][v] = col;

    for (auto &to: g[v]) {
        if (color[i][to] == -1) {
            dfs1(to, col, i, g);
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;


    vector<vector<ll>> g(n), gr(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }

    used.assign(n, false);

    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, g);
        }
    }

    reverse(ts.begin(), ts.end());

    color.assign(1, vector<ll>(n, -1));

    ll col = 0;

    for (auto &to: ts) {
        if (color[0][to] == -1) {
            dfs1(to, col, 0, gr);
            col++;
        }
    }

    ll q;
    cin >> q;
    vector<ll> s;
    if (q == 0) {
        for (ll i = 0; i < n; i++) {
            for (ll j = i; j < n; j++) {
                if (color[0][i] == color[0][j]) {
                    s.push_back(m + 1);
                } else {
                    s.push_back(0);
                }
            }
        }
    } else {
        while (q--) {
            ll a, b;
            cin >> a >> b;
            a--;
            b--;
            if (color[0][a] == color[0][b]) {
                s.push_back(m + 1);
            } else {
                s.push_back(0);
            }
        }
    }
    ll ans = 0;
    ll B = 1, b = 2e5;
    ll mod = 1e9 + 7;
    for (ll i = s.size() - 1; i >= 0; i--) {
        ans = (ans + B * s[i]) % mod;
        B = (B * b) % mod;
    }
    cout << ans;

}