#include <bits/stdc++.h>

using namespace std;

vector<int> p;

bool compare(int x, int y) {
    return p[x - 1] < p[y - 1];
}

bool divisible(int x, int y, int d) {
    return (p[x - 1] - p[y - 1]) % d == 0;
}

vector<int> solve(int l, int r) {
    if (l == r - 1) {
        return {l};
    }
    int m = (l + r) / 2;
    vector<int> x = solve(l, m);
    vector<int> y = solve(m, r);
    vector<int> ans;
    int i = 0, j = 0;
    while (i < x.size() && j < y.size()) {
        if (compare(x[i] + 1, y[j] + 1)) {
            ans.push_back(x[i]);
            i++;
        } else {
            ans.push_back(y[j]);
            j++;
        }
    }
    while (i < x.size()) {
        ans.push_back(x[i]);
        i++;
    }
    while (j < y.size()) {
        ans.push_back(y[j]);
        j++;
    }
    return ans;
}

vector<int> solve(int n) {
    vector<int> x = solve(0, n);
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[x[i]] = i + 1;
    }
    return ans;
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    p.assign(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }
    vector<int> a = solve(n);
    for (auto &i: a) {
        cout << i << ' ';
    }
}