#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll
vector<vector<pair<int, int>>> g;

vector<int> p;
vector<bool> used;
map<int, bool> mp;
void dfs(int v, int fn){
    used[v] = true;
    if(used[fn])
        return;
    for(auto [u, number] : g[v]){
        if(used[u])
            continue;
        if(used[fn])
            return;
        p.emplace_back(number);
        dfs(u, fn);
        if(used[fn])
            return;
        p.pop_back();
    }
}

void dfs1(int v, int fn){
    used[v] = true;
    if(used[fn])
        return;
    for(auto [u, number] : g[v]){
        if(used[u] || mp[number])
            continue;
        dfs1(u, fn);
    }
}
map<int, pair<int, int>> edge;
map<pair<int, int>, int> from;
pair<int, int> solve(int u, int v){
    fill(all(used), false);
    p.clear();
    mp.clear();
    dfs(u, v);
    if(!used[v])
        return {0, 0};
    fill(all(used), false);
    for(int i = 0; i < int(p.size()); i++)
        mp[p[i]] = true;
    dfs1(u, v);
    if(!used[v])
        return edge[p[0]];
    return {-1, -1};
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    used.resize(n + 1);
    g.resize(n + 1);
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        edge[i] = make_pair(u, v);
        from[make_pair(u, v)] = i;
        g[u].emplace_back(v, i);
    }
    int q;
    cin >> q;
    vector<pair<int, int>> query;
    while(q--){
        int u, v;
        cin >> u >> v;
        query.emplace_back(u, v);
    }
    if(query.empty()){
        for(int i = 1; i <= n; i++){
            for(int j = i; j <= n; j++)
                query.emplace_back(i, j);
        }
    }
    vector<int> ans;
    for(auto [u, v] : query){
        if(u == v){
            ans.emplace_back(m + 1);
            continue;
        }
        auto a1 = solve(u, v), b1 = solve(v, u);
        if((a1.first == 0 && a1.second == 0) || (b1.first == 0 && b1.second == 0)){
            ans.emplace_back(0);
            continue;
        }
        if((a1.first == -1 && a1.second == -1) && (b1.first == -1 && b1.second == -1)){
            ans.emplace_back(m + 1);
            continue;
        }
        if(a1.first == -1 && a1.second == -1)
            ans.emplace_back(from[b1]);
        else
            ans.emplace_back(from[a1]);
    }
    const int B = int(2e5);
    const int mod = int(1e9) + 7;
    int res = 0, pw = 1;
    reverse(all(ans));
    for(int i = 0; i < int(ans.size()); i++){
        res += (pw * ans[i]) % mod;
        res %= mod;
        pw = (pw * B) % mod;
    }
    cout << res;
    return 0;
}