#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define pll pair<ll,ll>

ll n, m, q;

struct SEG {
    vll arr;
    ll sz;

    void make(ll n) {
        for (sz = 1; sz <= n; sz <<= 1);
        arr.resize(sz*2, m+1);
    }

    void set(ll ind, ll val) {
        ind += sz;
        arr[ind]=val;
        while(ind>>=1)arr[ind]=min(arr[ind*2],arr[ind*2+1]);
    }

    ll query(ll l, ll r) {
        l += sz, r += sz;
        ll ans = m+1;
        while (l <= r) {
            if (l % 2 == 1) ans = min(ans, arr[l++]);
            if (r % 2 == 0) ans = min(ans, arr[r--]);
            l>>=1, r>>=1;
        }
        return ans;
    }
};

ll ans[2000][2000];
ll runID;
vll sccS;
const ll MOD = 1e9+7;
const ll MUL = 2e5;
vector<pll> edges;
vll interestingEdges;

void dfs(vector<vector<pll>>& graph, ll node, vll& vis, ll exclude=-1) {
    vis[node] = runID;
    for (pll v : graph[node]) {
        if (vis[v.first] != runID) {
            if (v.second == exclude) continue;
            interestingEdges.push_back(v.second);
            dfs(graph, v.first, vis, exclude);
        }
    }
    sccS.push_back(node);
}

void dfs2(vector<vector<pll>>& graph, ll node, vll& vis, vll& comp, ll compID, ll exclude=-1) {
    // cout << node << endl;
    vis[node] = runID;
    comp[node] = compID;
    for (pll v : graph[node]) {
        if (v.second == exclude) continue;
        if (vis[v.first] != runID) {
            interestingEdges.push_back(v.second);
            dfs2(graph, v.first, vis, comp, compID, exclude);
        }
    }
}

tuple<vvll ,vll, vvll> scc(vector<vector<pll>>& graph, vector<vector<pll>>& graphREV) { // return {core edges per comp, comp per node, nodes per comp}
    interestingEdges.clear();
    runID++;
    vll vis(n);
    for (ll i = 0; i < n; i++) {
        if (vis[i] != runID) {
            dfs(graph, i, vis);
        }
    }
    vll comp(n);
    ll compID = 0;
    runID++;
    while (!sccS.empty()) {
        ll i = sccS.back();
        sccS.pop_back();
        if (vis[i] != runID) {
            dfs2(graphREV, i, vis, comp, compID++);
        }
    }
    vvll ce(compID);
    vvll nodespercomp(compID);
    for (ll i = 0; i < n; i++) {
        nodespercomp[comp[i]].push_back(i);
    }
    for (ll e : interestingEdges) {
        if (comp[edges[e].first] == comp[edges[e].second]) ce[comp[edges[e].first]].push_back(e);
    }
    return {ce, comp, nodespercomp};
}

void scc2(vector<vector<pll>>& graph, vector<vector<pll>>& graphREV, vll& interesting, vll& comp, vll& vis, ll exclude) { // return {core edges per comp, comp per node, nodes per comp}
    runID++;
    for (ll i : interesting) {
        if (vis[i] != runID) {
            dfs(graph, i, vis, exclude);
        }
    }
    // for (ll v : sccS) cout << v << ' ';
    // cout << endl;
    ll compID = 0;
    runID++;
    while (!sccS.empty()) {
        ll i = sccS.back();
        sccS.pop_back();
        if (vis[i] != runID) {
            dfs2(graphREV, i, vis, comp, compID++, exclude);
        }
    }
}

int main() {
    cin >> n >> m;
    edges.resize(m);
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        edges[i] = {a, b};
    }
    cin >> q;
    if (m <= 8000) {
        vector<vector<pll>> graph(n);
        vector<vector<pll>> graphREV(n);
        for (ll i = 0; i < m; i++) {
            pll e = edges[i];
            graph[e.first].push_back({e.second, i});
            graphREV[e.second].push_back({e.first, i});
        }
        tuple<vvll ,vll, vvll> sep_ = scc(graph, graphREV);
        vvll cores = get<0>(sep_);
        vll sep = get<1>(sep_);
        // for (ll v : sep) cout << v << ' ';
        // cout << endl;
        vvll comps = get<2>(sep_);
        vll sep2(n);
        vll vis(n);
        vector<vector<pll>> graph2(n);
        vector<vector<pll>> graph2REV(n);
        for (ll i = 0; i < m; i++) {
            pll e = edges[i];
            if (sep[e.first] == sep[e.second]) {
                graph2[e.first].push_back({e.second, i});
                graph2REV[e.second].push_back({e.first, i});
            }
        }
        ll compID = n;
        for (ll i = 0; i < cores.size(); i++) {
            vll& cc = cores[i];
            sort(cc.begin(), cc.end());
            cc.erase(unique(cc.begin(), cc.end()),cc.end());
            // cout << "testing comp " << i << endl;
            // for (ll v : comps[i]) cout << v << ' ';
            for (ll j = 0; j < comps[i].size(); j++) {
                for (ll k = 0; k < comps[i].size(); k++) {
                    ans[comps[i][j]][comps[i][k]] = m+1;
                }
            }
            // cout << endl;
            for (ll e : cc) {
                // cout << "testing " << e << " in comp " << i << endl;
                // cout << edges[e].first << ' ' << edges[e].second << endl;
                scc2(graph2, graph2REV, comps[i], sep2, vis, e);
                // for (ll v : sep2) cout << v << ' ';
                // cout << endl;
                vector<pair<pll, ll>> pairs;
                for (ll n : comps[i]) {
                    pairs.push_back({{sep[n], sep2[n]}, n});
                }
                sort(pairs.begin(), pairs.end());
                pll last = {-1, -1};
                vll plast;
                vll cur;
                for (auto p : pairs) {
                    if (p.first != last) {
                        if (p.first.first != last.first) plast.clear();
                        else plast.insert(plast.end(), cur.begin(), cur.end());
                        cur.clear();
                        last = p.first, compID++;
                    }
                    for (ll con : plast) {
                        ans[con][p.second] = ans[p.second][con] = e+1;
                    }
                    cur.push_back(p.second);
                    sep[p.second] = compID;
                }
            }
        }
        stack<pll> queries;
        if (q) {
            for (ll i = 0; i < q; i++) {
                ll a, b;
                cin >> a >> b;
                a--, b--;
                queries.push({a, b});
                // cout << i << ' ' << j << ' ';
                // cout << ans[i][j] << endl;
            }
        } else {
            for (ll i = 0; i < n; i++) {
                for (ll j = i; j < n; j++) {
                    queries.push({i, j});
                    // cout << i << ' ' << j << ' ';
                    // cout << ans[i][j] << endl;
                }
            }
        }
        ll ansV = 0;
        ll mulV = 1;
        while (!queries.empty()) {
            ansV += mulV * ans[queries.top().first][queries.top().second];
            ansV %= MOD;
            mulV *= MUL;
            mulV %= MOD;
            queries.pop();
        }
        cout << ansV << endl;
        return 0;
    }
    ll cbde = 0;
    vll nedges(n, -1);
    vll pedges(n, -1);
    vll nedgeS(n);
    vll pedgeS(n);
    for (ll i = 0; i < m; i++) {
        pll e = edges[i];
        if (e.first+1 == e.second && nedges[e.first] == -1) nedges[e.first] = i, cbde++;
        else if (e.first == e.second+1 && pedges[e.second] == -1) pedges[e.second] = i, cbde++;
        else {
            if (e.first < e.second) {
                nedgeS[e.first]++;
                nedgeS[e.second]--;
            } else {
                pedgeS[e.second]++;
                pedgeS[e.first]--;
            }
        }
    }
    if (cbde == 2*(n-1)) {
        ll cuN = 0;
        ll cuP = 0;
        SEG seg1, seg2;
        seg1.make(n);
        seg2.make(n);
        for (ll i = 0; i + 1 < n; i++) {
            cuN += nedgeS[i];
            cuP += pedgeS[i];
            if (cuN > 0) nedges[i] = m;
            if (cuP > 0) pedges[i] = m;
            seg1.set(i, nedges[i]+1);
            seg2.set(i, pedges[i]+1);
        }
        stack<ll> vals;
        for (ll i = 0; i < q; i++) {
            ll a, b;
            cin >> a >> b;
            a--, b--;
            if (a > b) swap(a, b);
            vals.push(min(seg1.query(a, b-1), seg2.query(a, b-1)));
        }
        ll ansV = 0;
        ll mulV = 1;
        while (!vals.empty()) {
            ansV += mulV * vals.top();
            ansV %= MOD;
            mulV *= MUL;
            mulV %= MOD;
            vals.pop();
        }
        cout << ansV << endl;
        return 0;
    }
    vector<vector<pll>> graph(n);
    vector<vector<pll>> graphREV(n);
    for (ll i = 0; i < m; i++) {
        pll e = edges[i];
        graph[e.first].push_back({e.second, i});
        graphREV[e.second].push_back({e.first, i});
    }
    tuple<vvll ,vll, vvll> sep_ = scc(graph, graphREV);
    vll sep = get<1>(sep_);
    stack<pll> queries;
    if (q) {
        for (ll i = 0; i < q; i++) {
            ll a, b;
            cin >> a >> b;
            a--, b--;
            queries.push({a, b});
        }
    } else {
        for (ll i = 0; i < n; i++) {
            for (ll j = i; j < n; j++) {
                queries.push({i, j});
            }
        }
    }
    ll ansV = 0;
    ll mulV = 1;
    while (!queries.empty()) {
        ansV += mulV * (sep[queries.top().first] == sep[queries.top().second] ? m+1 : 0);
        ansV %= MOD;
        mulV *= MUL;
        mulV %= MOD;
        queries.pop();
    }
    cout << ansV << endl;
}