#include <iostream>
#include <vector>
using namespace std;

#define ll long long
ll const N=2e2+5;
ll const mul=2e5;
ll const mod=1e9+7;
vector<ll> g[N];
bool vis[N][N];
ll cnt[N][N];
pair<ll,ll> edge[N];
bool visited[N];

ll power(ll n,ll e,ll mod)
{
    if(e==0)
        return 1;
    else if(e==1)
        return n%mod;
    else
    {
        if(e%2==0)
        {
            ll x=power(n,e/2,mod);
            return (x*x)%mod;
        }
        else
        {
            ll x=power(n,e/2,mod);
            return (((x*x)%mod)*n)%mod;
        }
    }
}

void dfs(ll v,ll u)
{
    vis[u][v]=true;
    for(ll i:g[v])
        if(!vis[u][i])
            dfs(i,u);
}

void special_dfs(ll v, ll a, ll b)
{
	visited[v]=true;
	for(ll i:g[v])
		if((!(v==a and i==b) or cnt[v][i]>1) and !visited[i])
			special_dfs(i,a,b);
}

void solve()
{
    ll n,m;
    cin >> n >> m;
    for (ll i = 0; i < m; ++i)
    {
        ll u,v;
        cin >> u >> v;
        g[u].push_back(v);
        edge[i+1]={u,v};
        cnt[u][v]++;
    }
    for (ll i = 1; i <= n; ++i)
        dfs(i,i);
    ll q;
    cin >> q;
    ll K=q;
    ll ans=0;
    for (ll c = 0; c < q; ++c)
    {
        K--;
        ll a,b;
        cin >> a >> b;
        if(!vis[a][b] or !vis[b][a])
        	continue;
        else
        {
        	ll sign=0;
            for (ll i = 1; i <= m; ++i)
            {
            	for (int i = 0; i < n+2; ++i)
            		visited[i]=false;
            	ll u=edge[i].first,v=edge[i].second;
            	special_dfs(a,u,v);
            	if(!visited[b])
            	{
            		ans+=(i%mod)*power(mul,K,mod)%mod;
            		ans%=mod;
            		sign=1;
            		break;
            	}
            }
            if(sign==0)
            {
            	for (ll i = 1; i <= m; ++i)
	            {
	            	for (int i = 0; i < n+2; ++i)
            		visited[i]=false;
	            	ll u=edge[i].first,v=edge[i].second;
	            	special_dfs(b,u,v);
	            	if(!visited[a])
	            	{
	            		ans+=(i%mod)*power(mul,K,mod)%mod;
            			ans%=mod;
	            		sign=1;
	            		break;
	            	}
	            }
	            if(sign==0)
	            {
	            	ans+=((m+1)%mod)*power(mul,K,mod)%mod;
            		ans%=mod;
	            }
            }
        }
    }
    cout << ans%mod << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);
    // int t;
    // cin >> t;
    // while(t--)
        solve();
    return 0;
}