#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const long long N = 2005, mod = 1e9+7 , B = 2e5;
vector<int> G[N];
vector<int> v;
int n, m;
bool vis[N];
int g[N][N];
vector<int> path[N];
vector<pair<int,int> > edges;

int query(int x, int y)
{
  if(binary_search(path[x].begin(),path[x].end(),y) and binary_search(path[y].begin(),path[y].end(),x))
    return m+1;
  return 0;
}

bool dfs2(int s, int e)
{
  vis[s] = true;
  if(s==e) return true;
  bool sign = false;
  for(int  i=1;i<=n;i++)
    {
      if(g[s][i] and !vis[i])
	{
	  sign|=dfs2(i,e);
	  if(sign) break;
	}
    }
  return sign;
}

int query2(int a, int b)
{
  if(!binary_search(path[a].begin(),path[a].end(),b) or  !binary_search(path[b].begin(),path[b].end(),a))
    return 0;

  int p = 1;
  for(auto x:edges)
    {
      g[x.first][x.second]--;
      bool sign = dfs2(a,b);
      for(int i=1;i<=n;i++)vis[i]=false;
      sign&=dfs2(b,a);
      // cout << "dfs2("<<a<<", "<<b<<") = "<< sign << endl;
      g[x.first][x.second]++;
      for(int i=1;i<=n;i++)vis[i] = false;
      if(!sign)
	return p;
      p++;
    }
  return p;
}

void dfs(int s, int v)
{
  //cerr << s << endl;
  vis[s] = true;
  path[v].push_back(s);
  for(int i:G[s])
    if(!vis[i])
      dfs(i,v);
}

int main()
{
  cin>>n>>m;
  for(int i=0;i<m;i++)
    {
      int a, b;
      cin>>a>>b;
      edges.push_back(make_pair(a,b));
      G[a].push_back(b);
      g[a][b]++;
    }
  for(int i=1;i<=n;i++)
    if(!vis[i])
      {
	//cerr << "dfs("<<i<<"i\n)";
	dfs(i,i);
	sort(path[i].begin() , path[i].end());
	for(int j=1;j<=n;j++) vis[j] = false;
      }
  int q;
  cin>>q;
  if(q==0)
    {
      for(int i=1;i<=n;i++)
	for(int j=i;j<=n;j++)
	  v.push_back(query(i,j));
    }
  else
    {
      if(q<501 and n<201)
	{
	  //cerr << "in" << endl;
	  while(q--)
	    {
	      int a, b;
	      cin>>a>>b;
	      v.push_back(query2(a,b));
	      //      cout << v.back() << " ";
	    }
	  cout << endl;
	}
      else
	{
	  while(q--)
	    {
	      int a, b;
	      cin>>a>>b;
	      v.push_back(query(a,b));
	    }
	}
    }
  long long ans = 0, p = 1;
  reverse(v.begin() , v.end());
  for(int i:v)
    {
      //cerr << i << " ";
      ans += (i*p)%mod;
      ans%=mod;
      p*=B;
      p%=mod;
    }
  cout << ans << endl;
  return 0;
}
/*

 */
