// #include "sorting.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
using namespace std;
const int __MAXN = 500000 + 10;
int const N=5e5+5;
int __compareCnt;
int __n, __p[__MAXN];
int inda[N],indb[N];
bool compare(int x, int y)
{
    __compareCnt++;
    // cout<<x<<' '<<y<<endl;
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n))
    {
        std::cerr << "Invalid compare query!\n";
        exit(0);
    }
    // cout<<(__p[x]<__p[y])<<endl;
    return __p[x] < __p[y];
}

bool divisible(int x, int y, int d)
{
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n && 1 <= d && d <= __n))
    {
        std::cerr << "Invalid divisible query!\n";
        exit(0);
    }

    return abs(__p[x] - __p[y]) % d == 0;
}
void read()
{
    std::cin >> __n;
    for (int i = 1 ; i <= __n ; ++i)
    {
        std::cin >> __p[i];
    }
}
vector<int> dac(int l,int r){

    // cerr<<l<<' '<<r<<endl;
    if(l+1==r)
        return {1};
    int mid=((r+l))/2;
    vector<int> a=dac(l,mid);
    vector<int> b=dac(mid,r);
    // vector<int> ans((r-,0);
    for (int i = 0; i < a.size(); ++i)
        inda[a[i]]=l+i;
    for (int i = 0; i < b.size(); ++i)
        indb[b[i]]=mid+i;
    int p1=1,p2=1;
    int k=1;
    while(p1+l<=mid&&p2+mid<=r){
        // cout<<"q"<<endl;
        if(compare(inda[p1]+1,indb[p2]+1)){
            a[inda[p1]-l]=k;
            p1++;
            // cout<<100<<endl;
        }
        else{
            b[indb[p2]-mid]=k;
            p2++;
        }
        k++;
    }
    if(l==3&&r==6)
        cout<<p1<<' '<<p2<<"  r"<<k<<endl;
    while(p1+l<=mid){
        a[inda[p1]-l]=k;
        p1++;
        k++;
    }
    while(p2+mid<=r){
        b[indb[p2]-mid]=k;
        p2++;
        k++;
    }
    vector<int> ans;
    for (int i:a)
        ans.push_back(i);
    for (int i:b)
        ans.push_back(i);
    cout<<l<<' '<<r<<endl;
    for (int i:ans)
        cout<<i<<' ';
    cout<<endl<<endl;;
    return ans;
}
vector<int> solve(int n){
    return dac(0,n);
}
double score()
{
    int logn = 0;
    while ((1 << logn) < __n) ++logn;
    if (__compareCnt <= __n/2) return 1.;
    if (__compareCnt <= 2*__n/2) return 0.7;
    if (__compareCnt <= 2*__n) return 0.5;
    if (__compareCnt <= __n * logn) return 0.15;
    if (__compareCnt <= __n * (1+logn)) return 0.1;
    return 0.05;
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

int main ()
{
    // fastIO();
    read();

    std::vector < int > res = solve(__n);
    for(int i:res)
        cout<<i<<' ';
    cout<<endl;
    // if (res.size() != __n)
    // {
    //     std::cout << "Invalid result! WA!\n";
    //     exit(0);
    // }

    // for (int i = 1 ; i <= __n ; ++i)
    // {
    //     if (res[i-1] != __p[i])
    //     {
    //         std::cout << "Incorrect element! WA!\n";
    //         exit(0);
    //     }
    // }

    std::cout << "Correct!: " << score() << "%\n";
    return 0;
}