#include<iostream>
#include<vector>
#include<map>
using namespace std;
#define pb push_back

const long long N = 5e5 + 7;
const long long mod = 1e9 + 7;
const long long inf = 1e15;
const long long B = 200000;
vector<long long>graph[N];
map<pair<long long, long long>, long long>id;
vector<long long>assign;
bool visited[N];


void dfs(long long v)
{
	visited[v] = true;
	for (long long u : graph[v])
		if (!visited[u] and u != -1)
			dfs(u);
}




long long power(long long a, long long b)
{
	if (b == 0)
		return 1;
	if (b == 1)
		return a;
	long long ans = power(a, b / 2);
	ans *= ans;
	ans %= mod;
	if (b % 2)
		ans *= a;
	ans %= mod;
	return ans;
}


int main()
{
	long long n , m;
	cin >> n >> m;
	for (long long i = 0; i < m; ++i)
	{
		long long a, b;
		cin >> a >> b;
		graph[a].pb(b);
		id[ {a, b}] = i + 1;
	}

	long long q, temp;
	cin >> q;
	temp = q;
	if (q == 0)
		temp = (n * (n + 1)) / 2;
	if (q != 0)
	{
		while (q--)
		{
			long long a , b;
			cin >> a >> b;
			long long ans = 0;
			for (long long i = 1; i <= n; ++i)
				visited[i] = false;
			dfs(a);
			ans += visited[b];
			for (long long i = 1; i <= n; ++i)
				visited[i] = false;
			dfs(b);
			ans += visited[a];
			if (ans == 0 or ans == 1)
			{
				assign.pb(0);
				continue;
			}

			long long aux = inf , cnt = 0;
			for (long long i = 1; i <= n; ++i)
			{
				for (long long j = 0; j < graph[i].size(); ++j)
				{
					long long val = graph[i][j];
					graph[i][j] = -1;
					ans = 0;
					for (long long x = 1; x <= n; ++x)
						visited[x] = false;
					dfs(a);
					ans += visited[b];

					for (long long x = 1; x <= n; ++x)
						visited[x] = false;

					dfs(b);
					ans += visited[a];
					graph[i][j] = val;
					if (ans == 2)
						cnt++;
					else
						aux = min(aux, id[ {i, val}]);
				}
			}
			if (cnt == m)
				assign.pb(m + 1);
			else
				assign.pb(aux);
		}
	}
	else
	{
		for (long long i = 1; i <= n; ++i)
		{
			for (long long j = i; j <= n; ++j)
			{
				long long a , b;
				a  = i;
				b = j;
				long long ans = 0;
				for (long long i = 1; i <= n; ++i)
					visited[i] = false;
				dfs(a);
				ans += visited[b];
				for (long long i = 1; i <= n; ++i)
					visited[i] = false;
				dfs(b);
				ans += visited[a];
				if (ans == 0 or ans == 1)
				{
					assign.pb(0);
					continue;
				}

				long long aux = inf , cnt = 0;
				for (long long i = 1; i <= n; ++i)
				{
					for (long long j = 0; j < graph[i].size(); ++j)
					{
						long long val = graph[i][j];
						graph[i][j] = -1;
						ans = 0;
						for (long long x = 1; x <= n; ++x)
							visited[x] = false;
						dfs(a);
						ans += visited[b];

						for (long long x = 1; x <= n; ++x)
							visited[x] = false;

						dfs(b);
						ans += visited[a];
						graph[i][j] = val;
						if (ans == 2)
							cnt++;
						else
							aux = min(aux, id[ {i, val}]);
					}
				}
				if (cnt == m)
					assign.pb(m + 1);
				else
					assign.pb(aux);
			}
		}
	}

// for (long long i : assign)
// 	cout << i << " = ";
// cout << endl;
long long output = 0;
for (long long i = 0; i < assign.size(); ++i)
{
	long long p = power(B, temp - i - 1);
	p %= mod;
	p *= assign[i];
	p %= mod;
	output += p;
	output %= mod;
}
output %= mod;

cout << output << endl;


}