#include<iostream>
#include<vector>
#include<map>
#include<cstdio>
using namespace std;
#define pb push_back

const long long N = 2000 + 7;
const long long mod = 1e9 + 7;
const long long inf = 1e15;
const long long B = 200000;
vector<long long>graph[N];
map<pair<long long, long long>, long long>id;
vector<long long>assign;
bool visited[N];
bool matrix[N][N];

long long n , m;

void dfs2(int root , int v)
{
	matrix[root][v] = true;
	for (int u : graph[v])
		if (!matrix[root][u])
			dfs2(root, u);
}

void pre_processing()
{
	for (int i = 1; i <= n; ++i)
		dfs2(i, i);

}

void dfs(long long v)
{
	visited[v] = true;
	for (long long u : graph[v])
		if (!visited[u] and u != -1)
			dfs(u);
}


long long power(long long a, long long b)
{
	if (b == 0)
		return 1;
	if (b == 1)
		return a;
	long long ans = power(a, b / 2);
	ans *= ans;
	ans %= mod;
	if (b % 2)
		ans *= a;
	ans %= mod;
	return ans;
}


int main()
{
	scanf("%lld", &n);
	scanf("%lld", &m);
	for (long long i = 0; i < m; ++i)
	{
		long long a, b;
		scanf("%lld", &a);
		scanf("%lld", &b);
		graph[a].pb(b);
		id[ {a, b}] = i + 1;
	}

	long long q, temp;
	scanf("%lld", &q);

	pre_processing();

	temp = q;
	if (q == 0)
		temp = (n * (n + 1)) / 2;
	if (q != 0)
	{
		while (q--)
		{
			long long a , b;

			scanf("%lld", &a);
			scanf("%lld", &b);

			long long ans = 0;
			for (long long i = 1; i <= n; ++i)
				visited[i] = false;
			dfs(a);
			ans += visited[b];
			for (long long i = 1; i <= n; ++i)
				visited[i] = false;
			dfs(b);
			ans += visited[a];

			if (n > 200)
			{
				if (!matrix[a][b] or !matrix[b][a])
					assign.pb(0);
				else
					assign.pb(m + 1);
				continue;
			}

			//cout << "Noooooo" << endl;
			if (ans == 0 or ans == 1 and n <= 200)
			{
				assign.pb(0);
				continue;
			}

			long long aux = inf , cnt = 0;
			for (long long i = 1; i <= n; ++i)
			{
				for (long long j = 0; j < graph[i].size(); ++j)
				{
					long long val = graph[i][j];
					graph[i][j] = -1;
					ans = 0;
					for (long long x = 1; x <= n; ++x)
						visited[x] = false;
					dfs(a);
					ans += visited[b];

					for (long long x = 1; x <= n; ++x)
						visited[x] = false;

					dfs(b);
					ans += visited[a];
					graph[i][j] = val;
					if (ans == 2)
						cnt++;
					else
						aux = min(aux, id[ {i, val}]);
				}
			}
			if (cnt == m)
				assign.pb(m + 1);
			else
				assign.pb(aux);
		}
	}
	else
	{
		for (long long i = 1; i <= n; ++i)
		{
			for (long long j = i; j <= n; ++j)
			{
				long long a , b;
				a  = i;
				b = j;
				long long ans = 0;
				for (long long i = 1; i <= n; ++i)
					visited[i] = false;
				dfs(a);
				ans += visited[b];
				for (long long i = 1; i <= n; ++i)
					visited[i] = false;
				dfs(b);
				ans += visited[a];
				if (n > 200)
				{
					if (!matrix[a][b] or !matrix[b][a])
						assign.pb(0);
					else
						assign.pb(m + 1);
					continue;
				}
				else if (ans == 0 or ans == 1 and n <= 200)
				{
					assign.pb(0);
					continue;
				}


				long long aux = inf , cnt = 0;
				for (long long i = 1; i <= n; ++i)
				{
					for (long long j = 0; j < graph[i].size(); ++j)
					{
						long long val = graph[i][j];
						graph[i][j] = -1;
						ans = 0;
						for (long long x = 1; x <= n; ++x)
							visited[x] = false;
						dfs(a);
						ans += visited[b];

						for (long long x = 1; x <= n; ++x)
							visited[x] = false;

						dfs(b);
						ans += visited[a];
						graph[i][j] = val;
						if (ans == 2)
							cnt++;
						else
							aux = min(aux, id[ {i, val}]);
					}
				}
				if (cnt == m)
					assign.pb(m + 1);
				else
					assign.pb(aux);
			}
		}
	}

// for (long long i : assign)
// 	cout << i << " = ";
// cout << endl;
	long long output = 0;
	for (long long i = 0; i < assign.size(); ++i)
	{
		long long p = power(B, temp - i - 1);
		p %= mod;
		p *= assign[i];
		p %= mod;
		output += p;
		output %= mod;
	}
	output %= mod;
	printf("%lld\n", output);

}