#include<iostream>
#include<vector>
#include<map>
#include<cstdio>
using namespace std;
#define pb push_back

const long long N = 2000 + 7;
const long long mod = 1e9 + 7;
const long long inf = 1e15;
const long long B = 200000;


vector<long long>graph[N];
map<pair<long long, long long>, long long>id;
vector<long long>assign;
bool visited[N];
bool matrix[N][N];

long long n , m;

void dfs2(int root , int v)
{
	matrix[root][v] = true;
	for (int u : graph[v])
		if (!matrix[root][u])
			dfs2(root, u);
}

void pre_processing()
{
	for (int i = 1; i <= n; ++i)
		dfs2(i, i);

}




long long power(long long a, long long b)
{
	if (b == 0)
		return 1;
	if (b == 1)
		return a;
	long long ans = power(a, b / 2);
	ans *= ans;
	ans %= mod;
	if (b % 2)
		ans *= a;
	ans %= mod;
	return ans;
}


int main()
{
	scanf("%lld", &n);
	scanf("%lld", &m);
	for (long long i = 0; i < m; ++i)
	{
		long long a, b;
		scanf("%lld", &a);
		scanf("%lld", &b);
		graph[a].pb(b);
		id[ {a, b}] = i + 1;
	}

	long long q, temp;
	scanf("%lld", &q);

	pre_processing();

	temp = q;
	if (q == 0)
		temp = (n * (n + 1)) / 2;
	if (q != 0)
	{
		while (q--)
		{
			long long a , b;
			scanf("%lld", &a);
			scanf("%lld", &b);
			if (!matrix[a][b] or !matrix[b][a])
				assign.pb(0);
			else
				assign.pb(m + 1);
		}
	}
	else
	{
		for (long long i = 1; i <= n; ++i)
		{
			for (long long j = i; j <= n; ++j)
			{
				long long a , b;
				a  = i;
				b = j;
				if (!matrix[a][b] or !matrix[b][a])
					assign.pb(0);
				else
					assign.pb(m + 1);
			}
		}
		long long output = 0;
		for (long long i = 0; i < assign.size(); ++i)
		{
			long long p = power(B, temp - i - 1);
			p %= mod;
			p *= assign[i];
			p %= mod;
			output += p;
			output %= mod;
		}
		output %= mod;
		printf("%lld\n", output);

	}
	return 0;
}
