#include <iostream>
#include <map>
using namespace std;
const long long nmax = 1e5;
const long long mmax = 1e5;
const long long oo = 2000000000000000000LL;

struct autocar {
    long long poz; long long cost;
} a[nmax + 1];

struct copil {
    long long poz; long long cost;
} c[mmax + 1];

static inline long long maxim ( const long long &a, const long long &b ) {
    return a > b ? a : b;
}

map < int, int > norm;
int norma[nmax + 1];
int normc[mmax + 1];

struct aint {
    long long aint[4 * nmax];
    void update ( int node, int st, int dr, int poz, long long val ) {
        if ( st == dr ) {
            aint[node] = val;
            return;
        }
        int mij = ( st + dr ) / 2;
        if ( poz <= mij )
            update ( node + 1, st, mij, poz, val );
        else
            update ( node + 2 * ( mij - st + 1 ), mij + 1, dr, poz, val );
        aint[node] = maxim ( aint[node + 1], aint[node + 2 * ( mij - st + 1 )] );
    }
    long long query ( int node, int st, int dr, int a, int b ) {
        if ( st == a && dr == b )
            return aint[node];
        int mij = ( st + dr ) / 2;
        if ( b <= mij )
            return query ( node + 1, st, mij, a, b );
        else if ( a > mij )
            return query ( node + 2 * ( mij - st + 1 ), mij + 1, dr, a, b );
        return maxim ( query ( node + 1, st, mij, a, mij ),
                       query ( node + 2 * ( mij - st + 1 ), mij + 1, dr, mij + 1, dr ) );
    }
}aint;

int main() {
    long long n, m;
    cin >> n;

    for ( long long i = 1; i <= n; i++ )
        cin >> a[i].poz >> a[i].cost, norm[a[i].poz] = 1;

    cin >> m;
    for ( long long i = 1; i <= m; i++ )
        cin >> c[i].poz >> c[i].cost, norm[c[i].poz] = 1;

    int cheie = 0;
    for ( pair < int, int > x: norm )
        norm[x.first] = cheie++;

    for ( int i = 1; i <= n; i++ )
        norma[i] = norm[a[i].poz];
    for ( int i = 1; i <= m; i++ )
        normc[i] = norm[c[i].poz];

    int V = c[1].cost;
    for ( int i = 1; i <= n; i++ ) {
        aint.update ( 0, 0, cheie - 1, norma[i], ( long long ) a[i].poz * V - a[i].cost );
        cout << norma[i] << ' ' << -a[i].poz * V +  a[i].cost << '\n';
    }
    long long s = 0;
    for ( int i = 1; i <= m; i++ ) {
        s += ( long long ) c[i].poz * V - aint.query ( 0, 0, cheie - 1, 0, normc[i] );
        cout << s << ' ';
    }

    return 0;
}
