#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
#include <cmath>
#define ll long long
#define pii pair <int, int>
#define x first
#define y second
#pragma GCC optimize("Ofast")
#define int ll

using namespace std;

const int MOD = (int) 1e9 + 7;
const int B = (int) 2e5;

int n, m, q;

int power[1000005];
bool ok[2005][2005], viz[2005];
vector <int> g[2005];

void bfs(int start) {
    queue <int> q;
    q.push(start);
    ok[start][start] = 1;
    for (int i = 1; i <= n; i++)
        viz[i] = 0;

    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (viz[u])
            continue;
        viz[u] = true;

        for (int i = 0; i < g[u].size(); i++) {
            int v = g[u][i];
            if (ok[start][i] == 0) {
                ok[start][i] = 1;
                q.push(i);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    power[0] = 1;
    for (int i = 1; i <= 1e6; i++)
        power[i] = power[i - 1] * B % MOD;

    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }
    for (int i = 1; i <= n; i++) {
        bfs(i);
    }

    cin >> q;

    ll ans = 0;

    if (q == 0) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                int cnt = 0;
                if (ok[i][j])
                    cnt = m + 1;
                else
                    cnt = 0;

                int code = (i - 1) * n + j;
                ans = (ans + power[n * n - code] * cnt % MOD) % MOD;
            }
        }
    }
    else {
        for (int iq = 1; iq <= q; iq++) {
            int i, j;
            cin >> i >> j;
            int cnt = 0;
            if (ok[i][j])
                cnt = m + 1;
            else
                cnt = 0;

            ans = (ans + power[q - iq] * cnt % MOD) % MOD;
        }
    }

    cout << ans;

    return 0;
}