#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int ll
#define sz(x) (int)(x).size()

using pii = pair<int,int>;
using tii = tuple<int,int,int>;
using tiii = tuple<int,int,int,int>;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> oset;

const int nmax = 2e5 + 5;

const ll inf = (1LL << 60) + 5;

struct event {
	ll poz, cost, type;
	bool operator <(const event& x) const {
		return poz < x.poz || (poz == x.poz && type > x.type);
	}
	event(int a, int b, int c): poz(a), cost(b), type(c) {;}
};

namespace CHT {
	struct line {
		ll m, b;
		ll operator ()(const int& x) const {
			return m * x + b;
		}
		bool operator ()(const line& x, const line& y) const {
			return (x.b - b) * (m - y.m) >= (y.b - b) * (m - x.m);
		}
	};
	vector<line> cht;
	void insert(line x) {
		while(cht.size() > 1 && x(cht.rbegin()[1], cht.back()))
			cht.pop_back();
		cht.push_back(x);
	} 
	ll query(ll x) {
		if(cht.size() == 0)
			return inf;
		// cerr << "! " << x << '\n';
		// cerr << x << " == " << cht.size() << '\n';
		int lim = -1;
		for(int i = 18; i >= 0; i--) {
			if(lim + (1 << i) >= cht.size() - 1)
				continue;
			if(cht[lim + (1 << i)](x) >= cht[lim + (1 << i) + 1](x)) lim += (1 << i);
		}
		lim++;
		return cht[lim](x);
	}
}

using namespace CHT;

ll sum[nmax];
ll ssum[nmax];
ll dp[nmax];
ll val[nmax];
ll cnt[nmax];

#define ssum (ssum + 1)
#define sum (sum + 1)
#define val (val + 1)
#define dp (dp + 1)
#define cnt (dp + 1)

signed main() {
	int n, m;
	cin >> n;
	vector<event> evl, evr;
	for(int i = 1; i <= n; i++) {
		int a, b;
		cin >> a >> b;
		evl.emplace_back(a, b, 2);
	}	
	cin >> m;
	for(int i = 1; i <= m; i++) {
		val[i] = inf;
		int a, b;
		cin >> a >> b;
		evr.emplace_back(a, b, 1);
	}
	
	vector<event> ev;
	ev.reserve(n + m);
	merge(all(evl), all(evr), back_inserter(ev));
	
	
	for(int i = 0; i < ev.size(); i++) {
		auto [p, v, t] = ev[i];
		if(t == 1)
			ssum[i] = ssum[i - 1] + v,
			cnt[i] = cnt[i - 1] + 1,
			sum[i] = sum[i - 1] + v * p;
		else
			ssum[i] = ssum[i - 1],
			cnt[i] = cnt[i - 1],
			sum[i] = sum[i - 1];
	}	
	dp[-1] = 0;
	for(int i = 0; i < ev.size(); i++) {
		dp[i] = inf;
		ll s = 0, ss = 0;
		cht.clear();
		for(int j = i; j >= 0; j--) {
			auto [p, v, t] = ev[j];
			if(t == 1 && j <= i) {
				s += v * p;
				ss += v;
			}
			else {
				ll sofar = s - p * ss  + v + sum[j] + ssum[j] * p;
				ll panta = p; 
				CHT::insert(line{panta, sofar});
				// cerr << sofar << ' ' << panta << '\n';
				// cerr << sofar << ' ' << panta << ' ' << s << ' ' << ss << ' ' << sum[j] << ' ' << ssum[j] << ' ' << -ssum[j - 1] << ' ' <<  -sum[j - 1]  << '\n';
				
			}
			ll dpn = -sum[j - 1] + CHT::query(-ssum[j - 1]);
			cerr << - sum[j - 1] << ' ' << CHT::query(-ssum[j - 1]) << ' ' << dp[j - 1] << '\n';
			dp[i] = min(dp[j - 1] + dpn, dp[i]);
		}
		val[cnt[i]] = min(val[cnt[i]], dp[i]);
		// cerr << cnt[i] << ' ' << dp[i] << '\n';
		// cerr << '\n';
	}
	for(int i = 1; i <= m; i++) {
		cout << val[i] << ' ';
	}
	cout << '\n';
	// cout << dp[sz(ev) - 1] << '\n';
}
