#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include <iostream>
#define all(x) (x).begin(),(x).end()
#include "sorting.h"
using namespace std;

#define sz(x) (int)(x).size()

vector<int> atr;

const int nmax = 5e5 + 5;

double dp[nmax];
int go[nmax];


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

static int rnd(int x) {
	return rng() % x;
}


void init(vector<int>& tosort, int val = 1) {
	int N = sz(tosort);
	if(sz(tosort) == 2) {
		atr[tosort[0]] = 1,
		atr[tosort[1]] = 0;
		if(compare(tosort[0], tosort[1]))
			atr[tosort[0]] = 0,
			atr[tosort[1]] = 1;
		return;
	}
	if(sz(tosort) == 1) {
		atr[tosort[0]] = 0;
		return;
	}
	if(go[N] == 3) {
		vector<int> a[3];
		a[0].reserve(N / 3 + 1);
		a[1].reserve(N / 3 + 1);
		a[2].reserve(N / 3 + 1);
		vector<int> remain;
		remain.reserve(2 * N / 3 + 1);
		a[0].emplace_back(tosort[0]);
		for(int i = 1; i < sz(tosort); i++) {
			if(divisible(tosort[0], tosort[i], val * 3))
					a[0].emplace_back(tosort[i]);
			else
				remain.emplace_back(tosort[i]);
		}	
		a[1].emplace_back(remain[0]);
		for(int i = 1; i < sz(remain); i++) {
			if(divisible(remain[0], remain[i], val * 3))
				a[1].emplace_back(remain[i]);
			else
				a[2].emplace_back(remain[i]);
		}
		
		init(a[0], val * 3);
		init(a[1], val * 3);
		init(a[2], val * 3);
		
		for(auto x : tosort)
			atr[x] *= 3;
		int l = sz(tosort) / 3;
		sort(a, a + 3, [&](auto u, auto b) { return sz(u) < sz(b); });
		int v[3] = {a[0][0], a[1][0], a[2][0]};
		
		for(auto i : a[1])
			if(atr[i] < atr[v[1]])
				v[1] = i;
		for(auto i : a[2])
			if(atr[i] < atr[v[2]])
				v[2] = i;
		for(auto i : a[0])
			if(atr[i] < atr[v[0]])
				v[0] = i;			
		
		if(sz(a[1]) != l) {
			for(auto x : a[0])
				atr[x] += 2;
			if(!compare(v[1], v[2]))
				swap(a[1], a[2]);
			for(auto x : a[2])
				atr[x] += 1;
		}
		else if(sz(a[2]) != l) {
			if(!compare(v[0], v[1]))
				swap(a[1], a[0]);
			for(auto x : a[0])
				atr[x] += 1;
			for(auto x : a[1])
				atr[x] += 2;
		}
		else {
			random_shuffle(a, a + 3, rnd);
			v[0] = a[0][0];
			v[1] = a[1][0];
			v[2] = a[2][0];
			for(auto i : a[1])
				if(atr[i] < atr[v[1]])
					v[1] = i;
			for(auto i : a[2])
				if(atr[i] < atr[v[2]])
					v[2] = i;
			for(auto i : a[0])
				if(atr[i] < atr[v[0]])
					v[0] = i;		
			int yi = compare(v[0], v[1]), er = compare(v[0], v[2]);
			if(yi + er == 1) {
				for(auto x : a[0])
					atr[x]++;
				if(yi == 1) {
					for(auto x : a[1])
						atr[x] += 2;
				}
				else
					for(auto x : a[2])
						atr[x] += 2;
			}
			if(yi + er == 0) {
				int san = compare(v[1], v[2]);
				for(auto x : a[1])
					atr[x]++;
				for(auto x : a[2])
					atr[x]++;
				if(san == 1)
					for(auto x : a[2])
						atr[x]++;
				else
					for(auto x : a[1])
						atr[x]++;
			}
			else {
				int san = compare(v[1], v[2]);
				if(san == 1)
					for(auto x : a[2])
						atr[x]++;
				else
					for(auto x : a[1])
						atr[x]++;
			}
		}
		return;
	}
	
	vector<int> a[2];
	a[0].reserve(N / 2 + 1);
	a[1].reserve(N / 2 + 1);
	a[0].emplace_back(tosort[0]);
	for(int i = 1; i < N; i++) {
		if(divisible(tosort[0], tosort[i], val * 2))
			a[0].emplace_back(tosort[i]);
		else
			a[1].emplace_back(tosort[i]);
	}
	
	init(a[0], val * 2);
	init(a[1], val * 2);
	
	for(auto x : tosort)
		atr[x] *= 2;
	
	if(sz(a[0]) > sz(a[1]))
		swap(a[0], a[1]);
	
	if(a[0].size() != a[1].size()) {
		for(auto x : a[0])
			atr[x]++;
	}
	else {
		int u = a[1][0], v = a[0][0];
		for(auto i : a[1])
			if(atr[i] < atr[u])
				u = i;
		for(auto i : a[0])
			if(atr[i] < atr[v])
				v = i;
		
		if(!compare(v, u))
			swap(a[1], a[0]);
		for(auto x : a[1])
			atr[x] += 1;
	}
	return;
}

std::vector < int > solve(int N) {	
	dp[1] = 0;
	dp[2] = 1;
	for(int i = 3; i <= N; i++) {
		if((double)dp[(i + 1) / 2] + (double)dp[i / 2] + (double)(i % 2 == 0? 1. : 0.) < (double)dp[(i + 1) / 3] + (double)dp[(i + 2) / 3] + (double)dp[(i + 0) / 3] + (double)(i % 3 == 0? 2./3. + 2. : 1))	
			go[i] = 2;
		else
			go[i] = 3;
		dp[i] = min(dp[(i + 1) / 2] + dp[i / 2] + (i % 2 == 0? 1. : 0.), dp[(i + 1) / 3] + dp[(i + 2) / 3] + dp[(i + 0) / 3] + (i % 3 == 0? 2./3. + 2. : 1.));
	}
	// cerr << 2./3. << ' ' << dp[6] << ' ' << N << '\n';
	vector<int> vals(N);
	atr.resize(N + 1);
	for(int i = 1; i <= N; i++)
		vals[i - 1] = i;
	random_shuffle(all(vals), rnd);
	init(vals);
	for(auto &x : atr)
		x++;
	vector<int> rez;
	copy(1 + all(atr), back_inserter(rez));
	return rez;
}
