#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

#define pb push_back

const int64_t MOD = 1e9+7;
const int64_t B = 2e5;

const int NMAX = 2005;
const int QMAX = 2e6+5;

int n, m, q;
vector<int> g[NMAX];
int x, y;
int qx[QMAX], qy[QMAX];
vector<int64_t> s;

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        g[x].pb(y);
    }
    cin >> q;
    for (int i = 1; i <= q; i++)
        cin >> qx[i] >> qy[i];
}

bool has_path[NMAX][NMAX];
bool viz[NMAX];

void reset_viz() {
    for (int i = 0; i < NMAX; i++)
        viz[i] = 0;
}

void dfs(int x, int root) {
    has_path[root][x] = true;
    for (auto &v : g[x]) {
        if (!viz[v]) {
            viz[v] = true;
            dfs(v, root);
        }
    }
}

void case_q0() {
    for (int i = 1; i <= n; i++)
        for (int j = i; j <= n; j++) {
            qx[++q] = i;
            qy[q] = j;
        }
}

void solve_0_or_m_plus_1() {
    if (q == 0)
        case_q0();

    for (int i = 1; i <= n; i++) {
        reset_viz();
        dfs(i, i);
    }

    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++)
            if (has_path[i][j] & has_path[j][i])
                cout << i << ' ' << j << endl;

    for (int i = q; i >= 1; i--) {
        s.pb((has_path[qx[i]][qy[i]] & has_path[qy[i]][qx[i]]) * (m + 1));
    }
}

int main() {
    read();
    if (q <= 1e5)
        solve_0_or_m_plus_1();
    int64_t ans = 0;
    int64_t bb = 1;
    for (int i = s.size() - 1; i >= 0; i--) {
        ans = (ans + bb * s[i]) % MOD;
        bb = (bb * B) % MOD;
    }
    cout << ans;
    return 0;
}
