#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

#define pb push_back

const int64_t MOD = 1e9+7;
const int64_t B = 2e5;

const int NMAX = 2005;
const int MMAX = 1e5+5;
const int QMAX = 4e6+5;

int n, m, q;
vector<int> g[NMAX];
vector<int> path_idx[NMAX];
int dx[MMAX], dy[MMAX];
short qx[QMAX], qy[QMAX];
vector<int> s;

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        cin >> dx[i] >> dy[i];
        g[dx[i]].pb(dy[i]);
        path_idx[dx[i]].pb(i);
    }
    cin >> q;
    for (int i = 1; i <= q; i++)
        cin >> qx[i] >> qy[i];
}

bool has_path[NMAX][NMAX];
bool viz[NMAX];

void reset_viz() {
    for (int i = 0; i < NMAX; i++)
        viz[i] = 0;
}

void dfs(int x, int root) {
    has_path[root][x] = true;
    for (auto &v : g[x]) {
        if (!viz[v]) {
            viz[v] = true;
            dfs(v, root);
        }
    }
}

void case_q0() {
    for (int i = 1; i <= n; i++)
        for (int j = i; j <= n; j++) {
            qx[++q] = i;
            qy[q] = j;
        }
}

void subtask3() {
    if (q == 0)
        case_q0();

    for (int i = 1; i <= n; i++) {
        reset_viz();
        dfs(i, i);
    }

    for (int i = 1; i <= q; i++) {
        s.pb((has_path[qx[i]][qy[i]] & has_path[qy[i]][qx[i]]) * (m + 1));
    }
}

void dfs_without_path(int x, int path) {
    viz[x] = true;
    for (int i = 0; i < g[x].size(); i++) {
        int v = g[x][i];
        if (!viz[v] && path_idx[x][i] != path) {
            dfs_without_path(v, path);
        }
    }
}

int query_subtask2(int x, int y) {
    if (x == y)
        return m + 1;
    if (!has_path[x][y] || !has_path[y][x])
        return 0;
    for (int i = 1; i <= m; i++) {
        reset_viz();
        dfs_without_path(x, i);
        if (!viz[y])
            return i;
        reset_viz();
        dfs_without_path(y, i);
        if (!viz[x])
            return i;
    }
    return m + 1;
}

void subtask2() {
    for (int i = 1; i <= n; i++) {
        reset_viz();
        dfs(i, i);
    }
    for (int i = 1; i <= q; i++) {
        s.pb(query_subtask2(qx[i], qy[i]));
    }
}

int main() {
    read();
    if (q <= 500 && q != 0 && n <= 200 && m <= 1000)
        subtask2();
    else if (q <= 1e5)
        subtask3();
    int64_t ans = 0;
    int64_t bb = 1;
    for (int i = s.size() - 1; i >= 0; i--) {
        ans = (ans + bb * s[i]) % MOD;
        bb = (bb * B) % MOD;
    }
    cout << ans;
    return 0;
}
