#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int INF = 1e9 + 123;
const int MOD = 1e9 + 7;

int binpow(int n, int k) {
    int res = 1;
    while (k) {
        if (k & 1) res = (1ll * res * n) % MOD;
        n = (1ll * n * n) % MOD;
        k >>= 1;
    }
    return res;
}

//-----------------------------------------------

const int N = 503, M = 8003;

map <pair <int, int>, int> cnt_edges;
pair <int, int> e[100003];

int n, m;

vector <int> g[2003];
bool used[2003];

bool can[2003][2003];
int can_without[N][N];

vector <int> s;

void dfs(int v, pair <int, int> p) {
    used[v] = true;
    for (auto to : g[v])
        if (!used[to] && (v != p.first || to != p.second || cnt_edges[p] > 1))
            dfs(to, p);
}

void solve(int a, int b) {
    if (!can[a][b] || !can[b][a]) {
        s.push_back(0);
        return;
    }
    if (n > 500 || m > 8000) {
        s.push_back(m + 1);
        return;
    }
    if (can_without[a][b] != INF || can_without[b][a] != INF) {
        s.push_back(min(can_without[a][b], can_without[b][a]));
        return;
    }
    s.push_back(m + 1);
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; i ++) {
        int u, v;
        cin >> u >> v;
        u --, v --;
        g[u].push_back(v);
        e[i] = {u, v};
        cnt_edges[e[i]] ++;
    }

    for (int i = 0; i < n; i ++) {
        for (int u = 0; u < n; u ++) used[u] = false;
        dfs(i, {-1, -1});
        for (int j = 0; j < n; j ++) {
            can[i][j] = used[j];
        }
    }

    if (n <= 500 && m <= 8000) {
        for (int i = 0; i < n; i ++)
            for (int j = 0; j < n; j ++)
                can_without[i][j] = INF;

        for (int u = 0; u < m; u ++) {
            for (int i = 0; i < n; i ++) {
                for (int j = 0; j < n; j ++) used[j] = false;
                dfs(i, e[u]);
                for (int j = 0; j < n; j ++)
                    if (!used[j])
                        can_without[i][j] = min(can_without[i][j], u);
            }
        }
    }

    int q;
    cin >> q;
    if (q != 0) {
        while (q --) {
            int a, b;
            cin >> a >> b;
            a --, b --;
            solve(a, b);
        }
    }
    else {
        for (int i = 0; i < n; i ++)
            for (int j = i; j < n; j ++)
                solve(i, j);
    }
    //--------------------------------------------
    int K = s.size();
    int B = 2e5;
    int res = 0;
    for (int i = 1; i <= K; i ++) {
        res = (res + 1ll * s[i - 1] * binpow(B, K - i) % MOD) % MOD;
    }
    cout << res << '\n';
    return 0;
}