#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define ret g[e[i].first].push_back(e[i].second)

using namespace std;

const int N = 2222;
const int M = 1e5 + 128;

vector <pair<int,int>> g[N];
int n, m;

const ll MOD = 1e9 + 7;
const ll B = 2e5;

ll binpow(ll a, ll n) {
    ll res = 1ll;
    while (n) {
        if (n & 1)
            res *= a, res %= MOD;
        a *= a;
        a %= MOD;
        n >>= 1;
    }
    return res;
}

int t[4 * N];

void build(vector<int> &a, int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build(a, v << 1, tl, tm);
    build(a, v << 1 | 1, tm + 1, tr);
    t[v] = min(t[v << 1], t[v << 1 | 1]);
}

int get(int l, int r, int v, int tl, int tr) {
    if (tl > r || tr < l)
        return 2e9;
    if (l <= tl && tr <= r)
        return t[v];
    int tm = (tl + tr) >> 1;
    return min(get(l, r, v << 1, tl, tm), get(l, r, v << 1 | 1, tm + 1, tr));
}

char used[N][N];

void solve() {

    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back({b, i+1});
    }

    // construct such array, that a[i] and a[i+1] connected
    // degree of each vertex is 2 or 4
    // so, start from 2, 4, 4...4, 2

    int pt = -1;
    for (int i = 1; i <= n; i++)
        if ((int) g[i].size() == 1)
            pt = i;

    vector < char > was(n+1, false);
    vector < int > arr;

    was[pt] = true;
    arr.push_back(pt);

    bool block3 = false;

    while ((int) arr.size() != n) {
        bool ok = false;
        for (auto [to, i] : g[arr.back()])
            if (!was[to]) {
                was[to] = true;
                arr.push_back(to);
                ok = true;
                break;
            }
        if (!ok) {
            block3 = true;
            break;
        }
    }

    if (block3) {
        for (int i = 1; i <= n; i++) {
            queue <int> q;
            q.push(i);
            used[i][i] = true;
            while (!q.empty()) {
                int v = q.front(); q.pop();
                for (auto [to, j] : g[v])
                    if (!used[i][to])
                        used[i][to] = true, q.push(to);
            }
        }

        int q;
        cin >> q;

        vector < pair<int, int> > Q;
        if (!q) {
            for (int i = 1; i <= n; i++)
                for (int j = i; j <= n; j++)
                    Q.push_back({i, j});
        } else {
            for (int i = 0; i < q; i++) {
                int a, b;
                cin >> a >> b;
                Q.push_back({a, b});
            }
        }

        ll res = 0ll;

        ll K = Q.size();

        for (auto [a, b] : Q) {
            ll ans = used[a][b] & used[b][a];
            if (ans) ans = m+1;
            K--;
            ll st = binpow(B, K);
            st = (st * ans) % MOD;
            res = (res + st) % MOD;
        }

        cout << res << '\n';
        return;
    }

    vector <int> pos(n+1, -1);
    for (int i = 0; i < n; i++)
        pos[arr[i]] = i;

    // build segment tree on minimum index of edge on path from i to j
    vector <int> bld;
    fill(all(was), false);

    for (auto c : arr) {
        for (auto [to, i] : g[c])
            if (was[to])
                bld.push_back(i);
        for (auto [to, i] : g[c])
            if (!was[to])
                was[to] = true, bld.push_back(i);
    }

    assert((int) bld.size() % 2 == 0);

    vector <int> nxt;
    for (int i = 0; i < bld.size(); i += 2)
        nxt.push_back(min(bld[i], bld[i+1]));

    build(nxt, 1, 0, n - 1);

    int q;
    cin >> q;

    assert(q > 0);

    ll K = q, res = 0ll;

    for (int i = 0; i < q; i++) {
        int a, b;
        cin >> a >> b;
        int ans = get(min(pos[a], pos[b]), max(pos[a], pos[b])-1, 1, 0, n-1);
        K--;
        ll st = binpow(B, K);
        st = (st * ans) % MOD;
        res = (res + st) % MOD;
    }

    cout << res << '\n';
}

main() {
//    boost;
    solve();
    return 0;
}


