#include <bits/stdc++.h>
#include "sorting.h"

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define watch(x) cout << (#x) << " : " << x << '\n'

using namespace std;

const int N = 5e5 + 128;

bitset < N > prime;

void init() {
    prime.set();
    prime[0] = prime[1] = false;
    for (int i = 2; i < N; i++) {
        if (!prime[i])
            continue;
        for (int j = i + i; j < N; j += i) {
            if (j * j >= N)
                break;
            prime[j] = false;
        }
    }
}

vector < int > solve(int n) {

    if (n > 1e4) {
        vector <int> res(n);
        iota(all(res), 1);
        unordered_map <int, unordered_map <int, bool>> mp;
        sort(all(res), [&mp](const int& x, const int &y) -> bool {
            if (mp.count(x) && mp[x].count(y))
                return mp[x][y];
            bool r = compare(x, y);
            mp[x][y] = r;
            mp[y][x] = r^1;
            return r;
        });
        vector <int> tot(n);
        for (int i = 0; i < n; i++)
            tot[res[i]-1] = i + 1;
        return tot;
    }

    init();

    // need to find the smallest element
    int smallest = 1;
    for (int i = 2; i <= n; i++)
        if (compare(i, smallest))
            smallest = i;

    // so it's total N queries
    // need find distance between i and smallest

    vector <int> res(n, -1);
    res[smallest-1] = 1;

    vector <int> nice;
    for (int i = 2; i <= n; i++)
        if (prime[i])
            nice.push_back(i);

    for (int i = 0; i < n; i++) {
        if (smallest == i + 1)
            continue;

        // find divider
        int loc = -1;

        for (auto c : nice)
            if (divisible(smallest, i+1, c))
                loc = c;

        if (loc == -1) {
            res[i] = 2; continue;
        }

        // p[i]-p[smallest]=k*loc
        // p[i]=p[smallest]+k*loc
        // p[i]=1+k*loc

        int l = 1, r = n/loc;

        for (int m = l; m <= r; m++)
            if (divisible(smallest, i+1, loc*m))
                res[i] = 1+loc*m;
    }

    return res;
}
