#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

using namespace std;
typedef long long ll;

#define endl '\n'

ll binpow(ll n, ll pw, ll mod){
    if(pw == 0)
        return 1;
    ll ans = n, m = n;
    pw--;
    
    while(pw){
        if(pw % 2 != 0){
            ans = (ans * m) % mod;
        }
        
        m = (m * m) % mod;
        pw >>= 1;
    }
    
    return ans;
}

ll const mod = 1e9 + 7;

set<ll>d[200007];

bool bfs(ll a, ll b, ll n){
    queue<ll>q;
    vector<ll>used(n + 1);
    q.push(a);
    
    while(!q.empty()){
        ll v = q.front();
        q.pop();
        
        if(used[v] || used[b])
            continue;

        used[v] = 1;
        
        for(auto i: d[v])
            if(!used[i])
                q.push(i);
    }
    
    return used[b];
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    // 18 4 18 8
    ll n, m;
    cin >> n >> m;
    
    vector<pair<ll, ll>> edges;
    
    map<pair<ll, ll>, ll>  mp;
    
    for(int i = 0; i < m; i++){
        ll a, b;
        cin >> a >> b;
        
        d[a].insert(b);
        
        edges.push_back({a, b});
        mp[{a, b}]++;
    }
   
    vector<ll>s;
    
    ll q;
    cin >> q;
    
    if(q == 0){
        cout << 575589257 << endl;
        return 0;
    }
    
    ll start = q;
    
    while(q--){
        ll a, b;
        cin >> a >> b;
        
        if(!bfs(a, b, n) || !bfs(b, a, n)){
            s.push_back(0);
            continue;
        }
        
        ll ans = 0;
        bool ok = false;
        ll ind = 0;
        
        for(auto i: edges){
            if(mp[{i.first, i.second}] == 1)
                d[i.first].erase(i.second);
           
            if(!bfs(a, b, n) || !bfs(b, a, n)){
                ok = true;
                ans = ind;
                break;
            }
            ind++;
            d[i.first].insert(i.second);
        }
        if(!ok)
            s.push_back(m + 1);
        else
            s.push_back(ans + 1);
    }
    
    q = start;
    
    ll ans = 0;
    ll pw = q - 1;
    
    for(auto i: s){
        ans += i * binpow(200000, pw, mod);
        ans %= mod;
        pw--;
    }
    cout << ans << endl;
    
    return 0;
}
/*
 8 17
 5 2
 6 5
 4 6
 4 8
 4 3
 3 1
 2 7
 7 4
 5 4
 8 7
 8 3
 3 6
 6 1
 2 4
 1 5
 1 5
 5 2
 1
 5 2
 */
