#include "sorting.h"
#include <vector>
#include <set>

using namespace std;

bool compare(int, int);

bool divisible(int, int, int);

int MaxN = 0;

struct Factor {
    int p;
    int q;
};


int getDist(int a, int b) {
    int d = 2;
    int res = 1;
    for (int i = 2; i * i <= MaxN; ++i) {
        if (divisible(a + 1, b + 1, i)) {
            int p = i;
            while (divisible(a + 1, b + 1, p)) {
                p *= i;
            }
            p /= i;
            res *= p;
        }
        
    }
    return res;
}

vector<int> recSolve(int N, vector<int> v) {
    if (N == 1) {
        return {1};
    }
    if (N % 2 == 0) {
        vector<int> p(MaxN, -1);
        vector<int> pr(MaxN, -1);
        vector<bool> used(MaxN, false);
        for (int i = 0; i < N; ++i) {
            if (used[i])
                continue;
            for (int j = i + 1; j < N; ++j) {
                if (used[j])
                    continue;
                if (divisible(v[i] + 1, v[j] + 1, N / 2)) {
                    int a = v[i];
                    int b = v[j];
                    if (!compare(a + 1, b + 1)) {
                        swap(a, b);
                    }
                    p[a] = b;
                    pr[b] = a;
                    used[i] = true;
                    used[j] = true;
                    break;
                }
            }
        }
        vector<int> nV;
        for (int i = 0; i < v.size(); i++) {
            if (p[v[i]] != -1) {
                nV.push_back(v[i]);
            }
        }
        vector<int> al(MaxN, -1);

        auto res = recSolve(N / 2, nV);
        for (int i = 0; i < nV.size(); i++) {
            al[nV[i]] = res[i];
        }
        vector<int> ans(N);
        int num = 0;
        for (int i = 0; i < N; i++) {
            if (p[v[i]] != -1) {
                ans[i] = al[v[i]];
            } else {
                ans[i] = al[pr[v[i]]] + N / 2;
            }
        }

        return ans;
    } else {
        vector<bool> used(N, false);
        set<int> small;
        set<int> large;
        for (int i = 0; i < N; ++i) {
            if (used[i])
                continue;
            for (int j = i + 1; j < N; ++j) {
                if (used[j])
                    continue;
                if (divisible(v[i] + 1, v[j] + 1, N / 2 + 1)) {
                    int a = v[i];
                    int b = v[j];
                    if (!compare(a + 1, b + 1)) {
                        swap(a, b);
                    }
                    large.insert(b);
                    small.insert(a);
                    used[i] = true;
                    used[j] = true;
                    break;
                }
            }
        }
        vector<int> ans(N);
        int id = 0;
        for (int i = 0; i < N; i++) {
            if (!used[i]) {
                ans[i] = N / 2 + 1;
                id = i;
                break;
            }
        }

        for (int i = 0; i < N; i++) {
            if (id == i)
                continue;
            int el = v[i];
            int dist = getDist(el, v[id]);
            if (small.find(el) != small.end()) {
                ans[i] = N / 2 + 1 - dist;
            } else {
                ans[i] = N / 2 + 1 + dist;
            }
        }
        return ans;
    }
}


vector<int> solve(int N) {
    MaxN = N;
    vector<int> v(N);
    for (int i = 0; i < N; i++)
        v[i] = i;
    return recSolve(N, v);
}
